unit Callback;

interface

uses cstypes2, classes, sysutils, winprocs, wintypes;

type
  TCallback=Procedure(var Flags, AX, BX, CX, DX, SI, DI, DS, ES, BP : word);

  PClientRecord=^TClientRecord;
  TClientRecord=record
    Callback : TCallback; { Address of far address callback routine }
    ClientDataBindings : TClientDataBindings; { The 3 values... }
    Handle : TClientHandle;
    ClientInfo : TClientinfo;
  end;

Procedure AddCallback(ClientRecord : PClientRecord);
Procedure RemoveCallback(ClientHandle : TClientHandle);
procedure Locknew(var P : Pointer; Size : Word);
Procedure LockDispose(P : Pointer);

const
  Callbacks : TList = nil;

implementation

type
  PLockHeader=^TLockHeader;
  TLockHeader=Record
    MemHandle : THandle;
  end;

procedure Locknew(var P : Pointer; Size : Word);
var
  Handle : THandle;
begin
  Handle:=GlobalAlloc(GMEM_Fixed or GMEM_NoDiscard or GMEM_DDEShare,Size+SizeOf(TLockHeader));
  If handle<>0 then begin
    P:=GlobalLock(Handle);
    With TLockheader(P^) do
      MemHandle:=Handle;
    { Inc by size of header }
    Inc(PLockheader(P),1);
  end else
    P:=nil;
end;

Procedure LockDispose(P : Pointer);
var
  Handle : THandle;
begin
  dec(PLockHeader(P),1);
  With TLockHeader(P^) do
    Handle:=Memhandle;
  GlobalUnlock(Handle);
  GlobalFree(Handle);
end;

Procedure AddCallback;
begin
  Callbacks.Add(ClientRecord);
end;

Procedure RemoveCallback;
var
  c : Integer;
begin
  { Loop the callbacks }
  For C:=0 to Callbacks.Count-1 do begin
    { and find our handle }
    If PClientRecord(Callbacks[c])^.Handle=ClientHandle then begin
      { dispose }
      LockDispose(Callbacks[c]);
      { remove }
      Callbacks.Delete(c);
      { and stop }
      Break;
    end;
  end;
end;

Procedure ClearupCallbacks;
var
  ClientRecord : PClientRecord;
  c : Integer;
begin
  If Callbacks<>nil then begin
    For c:=0 to Callbacks.Count-1 do begin
      ClientRecord:=Callbacks[c];
      LockDispose(ClientRecord);
    end;
    Callbacks.Free;
    Callbacks:=nil;
  end;
end;

Procedure PrepareCallbacks;
begin
  AddExitProc(ClearupCallbacks);
  Callbacks:=TList.Create;
end;

begin
  PrepareCallbacks;
end.

