{**********************************************************************}
{ Unit archived using GP-Version                                       }
{ GP-Version is Copyright 1995, 1996 by Delta Lin Associates           }
{                                                                      }
{ For further information / comments, send an E-Mail to                }
{ info@dla.u-net.com                                                   }
{**********************************************************************}

{ $Log:  C:\PROJECTS\ARCHIVES\SMS\CARDSERV.UFV 
{
{   Rev 1.0    Fri 11 Apr 1997   10:31:31  <unknown>
{ Initial Revision
}

{ Card Services Interface for Turbo Pacal
  Written by Sam Liddicott November 1994
  For Cambell Scientific Ltd,
  (C) Campbell Scientific Ltd 1994-1997

  This pascal unit provides pascal functions and procedures equivalent to
  many lower level card services function calls.

  This unit attempts to load CSL-CS.DLL, which does the actual interfacing to
  card services

  vastly updated 1996-1997 to match new dll

  See the extra help functions further down for things like:
  CopyToCard and CopyFromCard - brilliant SRAM help functions

  Also note the RunSetup routine.  This MUST be called manually if neccessary now,
  PCCSetup is not run automatically if it needs condiguring.

  }

unit Cardserv;

interface
Uses cstypes2,sysutils, wintypes, dialogs;

const
  IDM_Callback=805; { Defined for Phoenix Card Sevices }

const
  CS : Boolean=false;  { CardSerices present }

var
  Error : Integer;
  CSinfo : TCSinfoDefault;         { See SmcTypes.pas }
  CSStyle : String;           { REAL or PHEONIX Card Services }
  Version : Longint;        { HEX version number of Card Services }

{ Prototypes to DLL which MUST be present when program runs }
{ **** ClientServices functions ****}
Function DeRegisterClient(Handle : TClientHandle; Error : PInteger) : Boolean;
function GetCardServicesInfo(var CSInfo; Size : Word; Error : PInteger) : boolean;
function GetCardServicesInfoDefault({ Expects fixed size buffer }
         var CSInfo : TCSInfoDefault; Error : PInteger) : boolean;
Function GetClientInfo(Handle : TClientHandle; var ClientInfo; Size : Word;
                    Error : PInteger) : Boolean;
function GetClientInfoDefault(Handle : TClientHandle; { Wxpects fixed size buffer }
         var ClientInfo : TClientInfoDefault; Error : PInteger) : Boolean;
{ GetEventMask }
Function GetStatus(Socket : TSocket; CardStatus, SocketStatus : PEventMask;
                          Error : PInteger) : Boolean;
Function RegisterClient(var NewHandle : TClienthandle;
                        U_Attributes : TClientAttributes;
                        U_Events : TEventMask;
                        U_Version: word;
                        U_ClientName,
                        U_VendorName: string;
                        U_Revision : word;
                        U_Date : word;
                        CallBack : Pointer;
                        DI : Word; { 3 client data bindings }
                        DS : Word;
                        SI : Word;
                        Error : PInteger) : Boolean;
{ResetCard}
Function SetEventMask(Handle : TClientHandle; EventMask : TEventMask;
         Error : PInteger) : Boolean;

{ **** Resource Management Functions ****}
function GetConfigurationInfo(Socket : TSocket; Handle : TClientHandle;
         var ConfigurationInfo : TConfigurationInfo; Error : PInteger):Boolean;
function MapMemPage(WinHandle : TClientHandle; Address : longint;
         Error : PInteger) : boolean;
{ Modify Configuration }
{ MOdify Window}
Function ReleaseConfiguration(Handle : TClientHandle; Socket : TSocket;
         Error : PInteger) : Boolean;
{releaseIO}
{releaseIRQ}
{releasesocketmask}
function ReleaseWindow(WinHandle : TClientHandle; Error : PInteger) : boolean;
Function RequestConfiguration(Handle : TClientHandle; var ConfigurationInfo : TSetableConfigurationInfo;
         Error : PInteger):Boolean;
{requestIRQ}
{requestsocketmask}
Function RequestWindow (Handle : TClientHandle; var WHandle : TClientHandle;
         socket : TSocket; var Attributes : TMemoryWindowAttributes;
         var baseaddress : longint; var size : longint; Error : PInteger) : Boolean;

{ **** Client Utilities **** }
{GetFirstPartition}
{GetFirstRegion}
{GetFirstTuple}
{GetNextPartition}
{GetNextRegion}
{GetNExtTuple}
{GetTupledata}
{AccessConfiguration}

{ **** Memory Functions **** }
{Check Erase Queue}
function CloseMemory(Memhandle : TClientHandle; Error : PInteger) : boolean;
{Copy memory}
{DeregisterEraseQueue}
function OpenMemory(Handle : TClientHandle; Var MemHandle : TClientHandle;
         Socket : TSocket; Attributes : TOpenMemoryAttributes;
         Address : longint; Error : PInteger) : Boolean;
function ReadMemory(Memhandle : TClientHandle; Address : longint; var buffer;
         size: longint; Error : PInteger) : boolean;
{RegisterEraseQueue}
function WriteMemory(Memhandle : TClientHandle; Attributes : TWriteMemoryAttributes;
         Address : longint; var buffer; size: longint; Error : PInteger) : boolean;

{ **** Advanced Client Services Functions **** }
{ Add socket services }
function AdjustResourceInfo(Action : TResourceOperation; var Resource : TResourceType;
         var Attributes : TResourceAttributes; var Address : longint; var Size : longint;
         Error : PInteger) : boolean;
function GetFirstClient(var Handle : TClientHandle; { Set socket to -1 for all sockets }
         Socket : TSocket; Error : PInteger) : Boolean;
function GetNextClient(OldHandle : TClientHandle;
         var Handle : TClientHandle; { Set socket to -1 for all sockets }
         socket : TSocket; Error : PInteger) : Boolean;
{ MapLogSocket}
{MapLogWindow}
{MapPhySocket}
{MapPhyWindow}
{ReturnSSEntry}
{RegisterMTD}
{RegisterTimer}
function ReleaseExclusiveAccess(Handle : TClientHandle; Socket : TSocket;
         Attributes : TReleaseExclusiveAttributes;
         Error : PInteger) : boolean;
{ReplaceSocketServices}
function RequestExclusiveAccess(Handle : TClientHandle; Socket : TSocket;
         Attributes : TRequestExclusiveAttributes;
         Error : PInteger) : boolean;
{SetRegion}
function ValidateCis(Socket : TSocket; Count : PWord; Error : PInteger) : boolean;
{Vender Specific }

{ **** Last but not least **** }
Function CardServices(CSFunction : Byte; Handle : TClientHandle; NewHandle : PClientHandle;
         Buffer : Pointer; Length : Word; ArgPointer : Pointer) : integer;
Function MapCardServices(CSType : TCSType; CSFunction : Byte; Handle : TClientHandle; NewHandle : PClientHandle;
         Buffer : Pointer; Length : Word; ArgPointer : Pointer) : integer;


{ **** Extra Helper Functions **** }
Function FindResource(Handle : TClientHandle; Resource : TResourceType;
                      Attributes : TResourceAttributes;
                      var base : longint; Physicalwindowsize : longint;
                      Error : PInteger) : boolean;
Function CopyFromCard(Handle : TClientHandle; Socket : TSocket;
         var Buffer; address : longint; size : longint;
         Error : PInteger) : Boolean;
Function CopyToCard(Handle : TClientHandle; Socket : TSocket;
         var Buffer; address : longint; size : longint; verify : boolean;
         Error : PInteger) : Boolean;
Function CardPresent(Socket : TSocket) : Boolean;
function IsWriteProtect(Socket : TSocket) : boolean;
Function CheckBattery(Socket : TSocket) : TBatteryStatus;
Function SocketCount : TSocket;

function CSDateToDate(CSDate : word) : TDateTime;
function EncodeCSDate(y,m,d : word) : Word;
{ When given a WORD coded BCD as XXXX meaning XX.XX returns a string as XX.XX }
function bcd2version(bcd : word) : string;

{ The default callback handler routine }
Procedure DefaultCallBack(var Flags, AX, BX, CX, DX, SI, DI, DS, ES, BP : word);

Function Checkversion(Version : Word) : Boolean;
Function DLL_Version : longint;
Function DLL_Info : PChar;
Function RunSetup : Boolean;

function Style : TCSType; {  whether or not we use REALL }
                           { or Phoenix card services }
function AllStyles : TCSDetected;

function MTD : PChar; { What kind of MTD method }

Function CheckInstallation(CSType : TCSType) : TCSType;
Procedure SearchInstallation(CSType : TCSType; var Detected : TCSDetected);

implementation

{ Prototypes to DLL which MUST be present when program runs }
{ **** ClientServices functions ****}
Function DeRegisterClient;
external 'csl_cs' name 'DeRegisterClient';

function GetCardServicesInfo;
external 'csl_cs' name 'GetCardServicesInfo';

function GetCardServicesInfoDefault;
external 'csl_cs' name 'GetCardServicesInfoDefault';

Function GetClientInfo;
external 'csl_cs' name 'GetClientInfo';

function GetClientInfoDefault;
external 'csl_cs' name 'GetClientinfoDefault';

{ GetEventMask }
Function GetStatus;
external 'csl_cs' name 'GetStatus';

Function RegisterClient;
external 'csl_cs' name 'RegisterClient';

{ResetCard}
Function SetEventMask;
external 'csl_cs' name 'SetEventMask';

{ **** Resource Management Functions ****}
function GetConfigurationInfo;
external 'csl_cs' name 'GetConfigurationInfo';

function MapMemPage;
external 'csl_cs' name 'MapMemPage';

{ Modify Configuration }
{ MOdify Window}
Function ReleaseConfiguration;
external 'csl_cs' name 'ReleaseConfiguration';

{releaseIO}
{releaseIRQ}
{releasesocketmask}
function ReleaseWindow;
external 'csl_cs' name 'ReleaseWindow';

Function RequestConfiguration;
external 'csl_cs' name 'ReuqestConfiguration';

{requestIRQ}
{requestsocketmask}
Function RequestWindow;
external 'csl_cs' name 'RequestWindow';

{ **** Client Utilities **** }
{GetFirstPartition}
{GetFirstRegion}
{GetFirstTuple}
{GetNextPartition}
{GetNextRegion}
{GetNExtTuple}
{GetTupledata}
{AccessConfiguration}

{ **** Memory Functions **** }
{Check Erase Queue}
function CloseMemory;
external 'csl_cs' name 'CloseMemory';
{Copy memory}
{DeregisterEraseQueue}
function OpenMemory;
external 'csl_cs' name 'OpenMemory';

function ReadMemory;
external 'csl_cs' name 'ReadMemory';

{RegisterEraseQueue}
function WriteMemory;
external 'csl_cs' name 'WriteMemory';

{ **** Advanced Client Services Functions **** }
{ Add socket services }
function AdjustResourceInfo;
external 'csl_cs' name 'AdjustResourceInfo';

function GetFirstClient;
external 'csl_cs' name 'GetFirstClient';

function GetNextClient;
external 'csl_cs' name 'GetNextClient';
{ MapLogSocket}
{MapLogWindow}
{MapPhySocket}
{MapPhyWindow}
{ReturnSSEntry}
{RegisterMTD}
{RegisterTimer}
function ReleaseExclusiveAccess;
external 'csl_cs' name 'ReleaseExclusiveAccess';

{ReplaceSocketServices}
function RequestExclusiveAccess;
external 'csl_cs' name 'RequestExclusiveAccess';

{SetRegion}
function ValidateCIS;
external 'csl_cs' name 'ValidateCIS';
{Vender Specific }

{ **** Last but not least **** }
Function CardServices;
external 'csl_cs' name 'CardServices';

Function MapCardServices;
external 'csl_cs' name 'MapCardServices';


{ **** Extra Helper Functions **** }
Function FindResource;
external 'csl_cs' name 'FindResource';

Function CopyFromCard;
external 'csl_cs' name 'CopyFromCard';

Function CopyToCard;
external 'csl_cs' name 'CopyToCard';

Function CardPresent;
external 'csl_cs' name 'CardPresent';

function IsWriteProtect;
external 'csl_cs' name 'IsWriteProtect';

Function CheckBattery;
external 'csl_cs' name 'CheckBattery';

Function SocketCount : TSocket;
external 'csl_cs' name 'SocketCount';

function CSDateToDate;
external 'csl_cs' name 'CSDateToDate';

function EncodeCSDate;
external 'csl_cs' name 'EncodeCSDate';

function bcd2version;
external 'csl_cs' name 'bcd2version';

Procedure DefaultCallback;
external 'csl_cs' name 'DefaultCallback';

Function CheckVersion;
external 'csl_cs' name 'CheckVersion';

Function DLL_Version;
external 'csl_cs' name 'DLL_Version';

Function DLL_Info;
external 'csl_cs' name 'DLL_Info';

Function RunSetup;
external 'csl_cs' name 'RunSetup'; 

function Style;
external 'csl_cs' name 'Style';

function AllStyles;
external 'csl_cs' name 'AllStyles';

Function CheckInstallation;
external 'csl_cs' name 'CheckInstallation';

Procedure SearchInstallation;
external 'csl_cs' name 'SearchInstallation';

function MTD;
external 'csl_cs' name 'MTD';

begin { read details for rest of program to ask us }
  If not CheckVersion($1300) then begin
    CS:=False;
    ShowMessage('Wrong Version CSL_CS.DLL'#13'PCCard Options will not be available');
  end else begin
    CS:=False;
    CS:=GetCardServicesInfoDefault(CSInfo,@Error);
    CS:=CSInfo.Signature='CS';
    CSStyle:=StrPas(CSTypes[Style]);
    Version:=DLL_Version;
  end;
end.
