unit cs2;
{ cardserv unit release 2! }
{ new conventions.  Result is still boolean, false for failed }
{ but with option to pass pointer to word/integer to receive error code }
{ if nil, then ignored. }
{ CardServices though returns an integer return value }
{ CardServices is now also passed a pointer to an integer, which if not nil }
{ will contain any new handle returned by the call.... }

interface

uses cstypes2, windos, sysutils, utils, winprocs, wintypes, callback;

{ Card Services Entry }
const
  CardServices : TCardServices = nil;

{ **** ClientServices functions ****}
Function DeRegisterClient(Handle : TClientHandle; Error : PInteger) : Boolean; export;
function GetCardServicesInfo(var CSInfo; Size : Word; Error : PInteger) : boolean; export;
function GetCardServicesInfoDefault({ Expects fixed size buffer }
         var CSInfo : TCSInfoDefault; Error : PInteger) : boolean; export;
Function GetClientInfo(Handle : TClientHandle; var ClientInfo; Size : word;
                    Error : PInteger) : Boolean; export;
function GetClientInfoDefault(Handle : TClientHandle; { Wxpects fixed size buffer }
         var ClientInfo : TClientInfoDefault; Error : PInteger) : Boolean; export;
{ GetEventMask }
Function GetStatus(Socket : TSocket; CardStatus, SocketStatus : PEventMask;
                          Error : PInteger) : Boolean; export;
Function RegisterClient(var NewHandle : TClienthandle;
                        U_Attributes : TClientAttributes;
                        U_Events : TEventMask;
                        U_Version: word;
                        U_ClientName,
                        U_VendorName: string;
                        U_Revision : word;
                        U_Date : word;
                        CallBack : Pointer;
                        DI : Word;
                        DS : Word;
                        SI : Word;
                        Error : PInteger) : Boolean; export;
{ResetCard}
Function SetEventMask(Handle : TClientHandle; EventMask : TEventMask;
         Error : PInteger) : Boolean; export;

{ **** Resource Management Functions ****}
function GetConfigurationInfo(Socket : TSocket; Handle : TClientHandle;
         var ConfigurationInfo : TConfigurationInfo; Error : PInteger):Boolean; export;
function MapMemPage(WinHandle : TClientHandle; Address : longint;
         Error : PInteger) : boolean; export;
{ Modify Configuration }
{ MOdify Window}
Function ReleaseConfiguration(Handle : TClientHandle; Socket : TSocket;
         Error : PInteger) : Boolean; export;
{releaseIO}
{releaseIRQ}
{releasesocketmask}
function ReleaseWindow(WinHandle : TClientHandle; Error : PInteger) : boolean; export;
Function RequestConfiguration(Handle : TClientHandle; var ConfigurationInfo : TSetableConfigurationInfo;
         Error : PInteger):Boolean; export;
{requestIRQ}
{requestsocketmask}
Function RequestWindow(Handle : TClientHandle; var WHandle : TClientHandle;
         socket : TSocket; var Attributes : TMemoryWindowAttributes;
         var baseaddress : longint; var size : longint; Error : PInteger) : Boolean; export;

{ **** Client Utilities **** }
{GetFirstPartition}
{GetFirstRegion}
{GetFirstTuple}
{GetNextPartition}
{GetNextRegion}
{GetNExtTuple}
{GetTupledata}
{AccessConfiguration}

{ **** Memory Functions **** }
{Check Erase Queue}
function CloseMemory(Memhandle : TClientHandle; Error : PInteger) : boolean; export;
{Copy memory}
{DeregisterEraseQueue}
function OpenMemory(Handle : TClientHandle; Var MemHandle : TClientHandle;
         Socket : TSocket; Attributes : TOpenMemoryAttributes;
         Address : longint; Error : PInteger) : Boolean; export;
function ReadMemory(Memhandle : TClientHandle; Address : longint; var buffer;
         size: longint; Error : PInteger) : boolean; export;
{RegisterEraseQueue}
function WriteMemory(Memhandle : TClientHandle; Attributes : TWriteMemoryAttributes;
         Address : longint; var buffer; size: longint; Error : PInteger) : boolean; export;

{ **** Advanced Client Services Functions **** }
{ Add socket services }
function AdjustResourceInfo(Action : TResourceOperation; var Resource : TResourceType;
         var Attributes : TResourceAttributes; var Address : longint; var Size : longint;
         Error : PInteger) : boolean; export;
function GetFirstClient(var Handle : TClientHandle; { Set socket to $FFFF for all sockets }
         Socket : TSocket; Error : PInteger) : Boolean; export;
function GetNextClient(OldHandle : TClientHandle;
         var Handle : TClientHandle; { Set socket to -1 for all sockets }
         socket : TSocket; Error : PInteger) : Boolean; export;
{ MapLogSocket}
{MapLogWindow}
{MapPhySocket}
{MapPhyWindow}
{ReturnSSEntry}
{RegisterMTD}
{RegisterTimer}
function ReleaseExclusiveAccess(Handle : TClientHandle; Socket : TSocket;
         Attributes : TReleaseExclusiveAttributes;
         Error : PInteger) : boolean; export;
{ReplaceSocketServices}
function RequestExclusiveAccess(Handle : TClientHandle; Socket : TSocket;
         Attributes : TRequestExclusiveAttributes;
         Error : PInteger) : boolean; export;
{SetRegion}
function ValidateCis(Socket : TSocket; Count : PWord; Error : PInteger) : boolean; export;
{Vender Specific }

{ **** Last but not least **** }
Function CallCardServices(CSFunction : Byte; Handle : TClienthandle; NewHandle : PClientHandle;
         Buffer : Pointer; Length : Word; ArgPointer : Pointer) : integer; export;
{ not exported }
Function DOSCardServices(CSFunction : Byte; Handle : TClientHandle; NewHandle : PClienthandle;
         Buffer : Pointer; Length : Word; ArgPointer : Pointer) : integer;

{ Private-ish }
Procedure CallBackController(Flags, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word); far;
Procedure CopyClientInfo(var Source : TClientInfo; var Dest : TClientInfo); far;

implementation

uses main;

type { these types are useless really outside this routine }
  TGetClientAttributesItems=(fcSocketOnly,fcbit2,fcbit3,fcbit4,fcbit5,fcbit6,fcbit7,
                             fcbit8,fcbit9,fcbit10);
  TGetClientAttributes=set of TGetClientAttributesItems;

  TGetClient=packed record
    Socket : TSocket;
    Attributes : TGetClientAttributes;
  end;

{----------------------------------------------------------}

Function CallCardServices;
begin
  Result:=CardServices(CSFunction,Handle,NewHandle,Buffer,Length,ArgPointer);
end;

Function DOSCardServices(CSFunction : Byte; Handle : TClientHandle; NewHandle : PClientHandle;
                           Buffer : Pointer; Length : Word; ArgPointer : Pointer) : integer;
var
  Reg : TRegisters;

begin
  Reg.AH:=$AF;
  Reg.AL:=CSFunction;
  Reg.DX:=Handle;
  Reg.DI:=Seg(Buffer^);
  Reg.SI:=Ofs(Buffer^);
  Reg.CX:=Length;
  Reg.ES:=Seg(ArgPointer^);
  Reg.BX:=Ofs(ArgPointer^);
  { sanity }
  Reg.DS:=DSeg;

  Intr($1A,Reg);
  If NewHandle<>nil then
    NewHandle^:=Reg.DX;
  If ((Reg.Flags and fCarry)<>0) and (reg.AX=0) then
    Reg.AX:=65535;
  DOSCardServices:=Reg.AX;
end;

Function DeRegisterClient;
var
  Code : integer;
begin
  Result:=False;
  Code:=CardServices($02,Handle,nil,nil,0,nil);
  If Assigned(Error) then begin
    Error^:=Code;
    Log(Format('Error: Error=%d, %s',[Code,GetError(Code)]));
  end;
  Result:=Code=0;
  { A bit of hack here too, to undo the RegisterClient hack }
  If Result then { Samfix, should we do it anyway....? }
                 { maybe mark it as bad and still accept callbacks, but eat them... }
    RemoveCallback(Handle);
end;

Function GetCardServicesInfo;
var
  Code : Integer;
begin
  Log(Format('GetCardServicesInfo: CSInfo=%p Size=%d Error=%p',[@CSInfo,Size,Error]));
  Code:=CardServices($0B,0,nil,nil,Size,@CSInfo);
  If Assigned(Error) then begin
    Error^:=Code;
    Log(Format('Error: Error=%d, %s',[Code,GetError(Code)]));
  end;
  GetCardServicesInfo:=Code=0;
end;

Function GetCardServicesInfoDefault;
begin
  Log(Format('GetCardServicesInfoDefault: CSInfo=%p Error=%p',[@CSInfo,Error]));
  Result:=GetCardServicesInfo(CSInfo,SizeOf(CSInfo),Error);
  Log('Return GetCardServicesInfoDefault');
end;

Function SetEventMask;
type
  TSetEventMaskArgs = record
    Attributes :  Word;
    EventMask : TEventMask;
    Socket : TSocket;
  end;
var
  Args : TSetEventMaskArgs;
  Code : Integer;
begin
  Args.Attributes:=0;
  Args.Socket:=0;
  Args.EventMask:=EventMask;
  Code:=CardServices($31,Handle,nil,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  SetEventMask:=Code=0;
end;

Function GetStatus;
type
  TGetStatusArgs=record
    Socket : TSocket;
    CardStatus : TCardStatus;
    SocketStatus : TSocketStatus;
  end;
var
  Args : TGetStatusArgs;
  Code : Integer;
begin
  Log(Format('CS-GetStatus Socket=%d',[Socket]));
  Args.Socket:=Socket;
  Code:=CardServices($0C,0,nil,nil,Sizeof(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  GetStatus:=Code=0;
  If CardStatus<>nil then
    CardStatus^:=Args.CardStatus;
  If SocketStatus<>nil then
    SocketStatus^:=Args.SocketStatus;
  Log(Format('CS-GetStatus Result=%d',[Code]));
end;

{ freak this about a bit }
{ So we call back our routine which does manipulations and then }
{ calls back their routine as a pascal procedure instead... }
Function RegisterClient;
var
   RegisterClientBlock : TRegisterClientBlock; { Used for client registration info }
   rES, rDI : Word;
   Code : Integer;
   ClientRecord : PClientRecord;
   Size : Word;
   NameLen : Word;
begin
  Log(Format('RegisterClient window=%d Callback=%p',[DI,Callback]));
  Result:=False;
  NameLen:=Length(U_Clientname)+Length(U_VendorName)+2;
  Size:=SizeOf(ClientRecord^)+NameLen;
  LockNew(Pointer(ClientRecord),Size);

  Log(Format('Namelen=%d, Size=%d',[NameLen,Size]));

  { Now fill up client info }
  with ClientRecord^ do begin
    ClientInfo.Attributes:=U_Attributes;

    ClientInfo.CSLevel:=U_Version;
    ClientInfo.Revision:=U_Revision;
    ClientInfo.RevDate:=U_Date;
    { SAMFIX what about the rest... }

    ClientInfo.NameOffset:=Sizeof(ClientInfo);
    ClientInfo.NameLength:=Length(U_ClientName)+1;
    Log(Format('Copy name to offset=%d from %p (%p)',
        [ClientInfo.NameOffset,@ClientInfo,Addr(PClientInfoDefault(@ClientInfo)^.Data[ClientInfo.NameOffset])]));
    StrPCopy(Addr(PClientInfoDefault(@ClientInfo)^.Data[ClientInfo.NameOffset]),U_ClientName);

    ClientInfo.VendorStringOffset:=ClientInfo.NameOffset+ClientInfo.NameLength;{nul}
    ClientInfo.VendorStringLength:=Length(U_Vendorname)+1;
    Log(Format('Copy vendor to offset=%d from %p (%p)',
      [ClientInfo.VendorStringOffset,@ClientInfo,Addr(PClientInfoDefault(@ClientInfo)^.Data[ClientInfo.VendorStringOffset])]));
    StrPCopy(Addr(PClientInfoDefault(@ClientInfo)^.Data[ClientInfo.VendorStringOffset]),U_VendorName);

    ClientInfo.InfoLen:=NameLen+SizeOf(ClientRecord^.ClientInfo);
  end;

  { Fix up the users REAL details here in this record for later }
  @ClientRecord^.Callback:=Callback;
  With ClientRecord^ do begin
    ClientDataBindings.DS:=DS;
    ClientDataBindings.SI:=SI;
    ClientDataBindings.DI:=DI;   { so we can post a message }
    ClientDataBindings.R:=0;           { reserved }
  end;
  With RegisterClientBlock do begin
    Attributes:=U_Attributes;
    EventMask:=U_Events;
    Version:=U_Version;
    { now stuff in our callback info and such }
    ClientDataBindings.DS:=DSeg;       { cos we need our DS value }
    ClientDataBindings.DI:=Seg(ClientRecord^);
    ClientDataBindings.SI:=Ofs(ClientRecord^);
    ClientDataBindings.R:=0;
  end;

  { Always pass address of Callback controller.... it will call real address and such }
  Log('CS-RegisterClient about to call cardservices');
  Code:=CardServices($10,0,@NewHandle,@CallbackController,SizeOf(RegisterClientBlock),@RegisterClientBlock);
  Log(Format('CS-RegisterClient result=%d',[Code]));
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
  If Result then begin
    ClientRecord^.Handle:=NewHandle;
    AddCallback(ClientRecord);
  end else
    LockDispose(ClientRecord);
  Log(Format('Done RegisterClient, Code=%d',[Code]));
end;

Function GetConfigurationInfo;
var
  Code : Integer;
begin
  ConfigurationInfo.Socket:=Socket;
  Code:=CardServices($4,Handle,nil,nil,SizeOf(ConfigurationInfo),@ConfigurationInfo);
  If Assigned(Error) then Error^:=Code;
  GetConfigurationInfo:=Code=0;
end;

Function RequestConfiguration;
var
  Code : Integer;
begin
  Code:=CardServices($30,Handle,nil,nil,SizeOf(ConfigurationInfo),@ConfigurationInfo);
  If Assigned(Error) then Error^:=Code;
  RequestConfiguration:=Code=0;
end;

Function ReleaseConfiguration;
var
  Code : Integer;
begin
  Code:=CardServices($1E,Handle,nil,nil,SizeOf(Socket),@Socket);
  If Assigned(Error) then Error^:=Code;
  ReleaseConfiguration:=Code=0;
end;

Function GetClientinfo;
var
  Code : Integer;
begin
  Code:=CardServices($3,Handle,nil,nil,Size,@ClientInfo);
  If Assigned(Error) then Error^:=Code;
  GetClientInfo:=Code=0;
end;

Function GetClientInfoDefault;
begin
  ClientInfo.MaxLen:=SizeOf(ClientInfo);
  GetClientInfoDefault:=GetClientInfo(Handle,ClientInfo,ClientInfo.Maxlen,Error);
end;

Function GetFirstClient;
var
  Code : Integer;
  Options : TGetClient;
begin
  if Socket>=0 then begin
    Options.Socket:=Socket;
    Options.Attributes:=[fcSocketOnly];
  end else begin
    Options.Attributes:=[];              
  end;
  Code:=CardServices($E,0,@Handle,nil,SizeOf(Options),@Options);
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
end;

Function GetNextClient;
var
  Code : Integer;
  Options : TGetClient;
begin
  if Socket>=0 then begin
    Options.Socket:=Socket;
    Options.Attributes:=[fcSocketOnly];
  end else begin
    Options.Attributes:=[];
  end;
  Code:=CardServices($2A,OldHandle,@Handle,nil,SizeOf(Options),@Options);
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
end;

Function OpenMemory;
var
  Code : Integer;
  Args : TOpenMemoryArgs;
begin
  Args.Socket:=Socket;
  Args.Attributes:=Attributes;
  Args.Address:=Address;
  Code:=CardServices($18,Handle,@MemHandle,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
end;

{SAMFIX what about realmode map of buffer}
Function WriteMemory;
var
  Code : Integer;
  Args : TWriteMemoryArgs;
begin
  Args.Attributes:=Attributes;
  Args.Address:=Address;
  Args.Count:=Size;
  Code:=CardServices(csWriteMemory,memHandle,nil,@Buffer,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
end;

Function ReadMemory;
var
  Code : Integer;
  Args : TReadMemoryArgs;

begin
  Log(Format('CS-ReadMemory: Size=%d, Address=%d, Buffer=%p',[Size,Address,@Buffer]));
  Args.Address:=Address;
  Args.Count:=Size;
  Code:=CardServices(csReadMemory,memHandle,nil,@Buffer,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
  Log(Format('CS-ReadMemory: Result=%d',[Code]));
end;

Function CloseMemory;
var
  Code : Integer;
begin
  Code:=CardServices($0,MemHandle,nil,nil,0,nil);
  If Assigned(Error) then Error^:=Code;
  CloseMemory:=Code=0;
end;

Function RequestExclusiveAccess;
var
  Code : Integer;
  Args : TRequestExclusiveArgs;
begin
  Args.Socket:=Socket;
  Args.Attributes:=[];
  Code:=CardServices($2C,Handle,nil,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  RequestExclusiveAccess:=Code=0;
end;

Function ReleaseExclusiveAccess;
var
  Code : Integer;
  Args : TReleaseExclusiveArgs;
begin
  Args.Socket:=Socket;
  Args.Attributes:=[];
  Code:=CardServices($2D,Handle,nil,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  ReleaseExclusiveAccess:=Code=0;
end;

Function ValidateCIS;
var
  Code : Integer;
  Args : TValidateCISArgs;
begin
  Args.Socket:=Socket;
  Code:=CardServices($2B,0,nil,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  If Assigned(Count) then Count^:=Args.Chains;
  ValidateCIS:=Code=0;
end;

Function RequestWindow;
var
  Args : TRequestWindowArgs;
  VAnswer : Longint;
  Code : Integer;
begin
  Args.socket:=socket;
  Args.Attributes:=attributes;
  Args.Address:=baseaddress;
  Args.size:=size;
  Args.AccessSpeed.DeviceSpeed:=ds250ns; {SAMFIX find real speed}
  Code:=CardServices(csRequestWindow,Handle,@WHandle,nil,Sizeof(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  Attributes:=Args.Attributes;
  BaseAddress:=Args.Address;
  Size:=Args.Size;
  result:=Code=0;
end;

function MapMemPage;

var
  Args : TMapMemPageArgs;
  Code : Integer;
begin
  Args.Page:=0;
  Args.Address:=Address;
  Code:=CardServices($14,WinHandle,nil,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  Result:=Code=0;
end;

Function ReleaseWindow;
var
  Code : Integer;
begin
  Code:=CardServices($1D,WinHandle,nil,nil,0,nil);
  If Assigned(Error) then Error^:=Code;
  ReleaseWindow:=Code=0;
end;

function AdjustResourceInfo;
var
  Code : Integer;
  Args : TAdjustResourceArgs;

begin
  AdjustResourceInfo:=False;
  Args.Resource:=Resource;
  Args.Address:=Address;
  Args.Size:=Size;
  Args.MEMAttributes:=Attributes;
  Args.Action:=Action;

  Code:=CardServices($35,0,nil,nil,SizeOf(Args),@Args);
  If Assigned(Error) then Error^:=Code;
  Resource:=Args.Resource;
  Attributes:=Args.MEMAttributes;
  Size:=Args.size;
  Address:=Args.Address;

  AdjustResourceInfo:=Code=0;
end;

{$S-}{ no stack checking in this bit }
{ This routine processes a $14 callback }
Procedure CopyClientInfo(var Source : TClientInfo; var Dest : TClientInfo);
var
  CopySize : Word;
  MaxLen : Word;
begin
  If (Dest.Attributes * ClientInfoSubfunction)<>[] then
    exit;
  MaxLen:=Dest.MaxLen;
  CopySize:=Min(Source.InfoLen,Dest.MaxLen);
  Move(Source,Dest,CopySize);
  Dest.InfoLen:=Source.InfoLen;
  Dest.MaxLen:=MaxLen;
end;

Procedure CallBackController(Flags, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
{ Note: Even though the above are not set as VAR parameters they WILL get
  passed back to card services when modified.  Just beleive it. }
var
  ClientRecord : PClientRecord;
const
  locals=sizeof(ClientRecord);
begin
  asm
    mov sp,bp
    pop bp {SAMFIX is this OK?}

    pushf
    push ax          { push all these registers onto our own stack }
    push bx          { to make the paramters which this routines   }
    push cx          { is 'expecting'                              }
    push dx
    push si
    push di
    push ds
    push es
    push bp

    push ax          { 3 dummys for the return address we are faking }
    push ax          { which is FAR and has 2 words, and one for the }
    push bp          { BP which normally gets pushed                 }
                     { The real BP and return address are on the real stack }

    mov bp,sp        { bp is used to point to the base of the parameters }
    sub sp,locals    { fake local vars }
                     { and  that is the end of the magic }
  end;
  { Now call a real routine with these registers as parameters }
  ClientRecord:=Ptr(DI,SI);

  if (Byte(AX)=cbClientInfo) then begin      { Was it a request to supply client info? }
    CopyClientInfo(ClientRecord^.ClientInfo,
                   TClientInfo(Ptr(ES,BX)^));

  end else begin
    { patch in freakery values }
    DI:=ClientRecord^.ClientdataBindings.DI;
    SI:=ClientRecord^.ClientdataBindings.SI;
    DS:=ClientRecord^.ClientDataBindings.DS;
    { and make real callback }
    ClientRecord^.CallBack(flags, AX, BX, CX, DX, SI, DI, DS, ES, BP);
  end;

  asm
    mov sp,bp

    pop bp
    pop ax
    pop ax   { 3 dummies }

    pop bp
    pop es
    pop ds
    pop di
    pop si
    pop dx
    pop cx
    pop bx
    pop ax
    popf

    retf
  end;              	{ Back to card services }
end;

end.
