{**********************************************************************}
{ Unit archived using GP-Version                                       }
{ GP-Version is Copyright 1995, 1996 by Delta Lin Associates           }
{                                                                      }
{ For further information / comments, send an E-Mail to                }
{ info@dla.u-net.com                                                   }
{**********************************************************************}

{ $Log:  C:\PROJECTS\ARCHIVES\SMS\CSTYPES2.UFV 
{
{   Rev 1.0    Fri 11 Apr 1997   10:31:33  <unknown>
{ Initial Revision
}

unit Cstypes2;

interface

uses sysutils, winprocs, wintypes;

const
  WM_DEVICECHANGE     = 537;
  DBT_DevNodesChanged = 7;

  { My Errors (negative) }
  ceCannotAllocateBufferBuffer=-1;

  { Card services errors }
  ceNoError=$0;
  ceInvalidAdaptor=$1;
  ceInvalidAttribute=$2;
  ceInvalidBaseSystemMemoryAddress=$3;
  ceInvalidEDCGenerator=$4;
  ceERROR_0x05=$5;
  ceInvalidIRQLevel=$6;
  ceInvalidCardOffset=$7;
  ceInvalidPage=$8;
  ceIncompleteReadRequest=$9;
  ceInvalidWindowSize=$a;
  ceInvalidSocket=$b;
  ceERROR_0x0C=$c;
  ceInvalidWindowType=$d;
  ceInvalidVCCLevel=$e;
  ceInvalidVpp1orVpp2Level=$f;
  ceERROR_0x10=$10;
  ceInvalidWindow=$11;
  ceIncompleteWriteRequest=$12;
  ceERROR_0x13=$13;
  ceNoCardPresent=$14;
  ceFunctionNotSupported=$15;
  ceInvalidMode=$16;
  ceInvalidSpeed=$17;
  ceBusy=$18;
  ceUndefinedError=$19;
  ceWriteProtectFailure=$1a;
  ceArgumentLengthInvalid=$1b;
  ceArgumentInvalid=$1c;
  ceConfigurationHasBeenLocked=$1d;
  ceResourceInUse=$1e;
  ceNoMoreItemsAvailable=$1f;
  ceOutOfResources=$20;
  ceInvalidhandle=$21;

  { Card Services Functions }
  csDeRegisterClient=$2;
  csGetCardServicesInfo=$B;
  csGetClientinfo=$3;
  csGetEventMask=$2E;
  csGetStatus=$0C;
  csRegisterClient=$10;
  csResetCard=$11;
  csSetEventMask=$31;

  csGetConfigurationinfo=$4;
  csMapMemPage=$14;
  csModifyConfiguration=$27;
  csReleaseConfiguration=$1E;
  csReleaseIO=$1B;
  csReleaseIRQ=$1C;
  csReleaseSocketMask=$2F;
  csReleaseWindow=$1D;
  csRequestConfiguration=$30;
  csrequestIO=$1F;
  csRequestIRQ=$20;
  csRequestSocketmask=$22;
  csRequestWindow=$21;

  csGetFirstPartition=$5;
  csGetFirstRegion=$6;
  csGetFirstTuple=$7;
  csGetNextPartition=$8;
  csGetNextRegion=$9;
  csGetNextTuple=$A;
  csTupledata=$D;
  csAccessConfiguration=$36;

  csCheckEraseQueue=$26;
  csCloseMemory=$0;
  csCopymemory=$1;
  csDeregisterEraseQueue=$25;
  csOpenMemory=$18;
  csReadMemory=$19;
  csRegisterEraseQueue=$F;
  csWriteMemory=$24;

  csAddSocketServices=$32;
  csAdjustResourceInfo=$35;
  csGetFirstClient=$E;
  csGetNextClient=$2A;
  csMapLogicalSocket=$12;
  csMapLogicalWindow=$13;
  csMapPhysicalSocket=$15;
  csMapPhysicalWindow=$16;
  csModifyWindow=$17;
  csReturnSSEntry=$23;
  csRegisterMTD=$1A;
  csRegisterTimer=$28;
  csReleaseExclusive=$2D;
  csReplaceSocketServices=$33;
  csRequestExclusive=$2C;
  csSetRegion=$29;
  csValidateCS=$2B;
  csVendorSpecific=$34;

  { Card Services Callbacks }
  cbBatteryDead=$1;
  cbBatteryLow=$2;
  cbCardLock=$3;
  cbCardReady=$4;
  cbCardRemoval=$5;
  cbCardUnlock=$6;
  cbEjectionComplete=$7;
  cbEjectionRequest=$8;
  cbInsertionComplete=$9;
  cbInsertionRequest=$a;
  cbPMResume=$b;
  cbPMSuspend=$c;
  cbExclusiveComplete=$d;
  cbExclusiveRequest=$e;
  cbResetPhysical=$f;
  cbResetRequest=$10;
  cbCardReset=$11;
  cbMTDRequest=$12;
  {Unused $13}
  cbClientInfo=$14;
  cbTimerExpired=$15;
  cbSSUpdated=$16;
  cbWriteProtect=$17;
  { skip a few }
  cbCardInsertion=$40;
  { skip a few }
  cbResetComplete=$80;
  cbEraseComplete=$81;
  cbRegistrationComplete=$82;

type
  LongRec = record
    Lo, Hi: Word;
  end;

  TCSType=(csUnknown,csNone,csAuto,csRealMode,csRealProt16,csBadRealProt16,csProt16,csProt32,
           csVXD,csPhoenix);
  TCSDetected=set of TCSType;

  TMTDOptionItems=(mtdAuto,mtdYes,mtdNo);
const
  MTDAutoOrder : Array [0..1] of TMTDOptionItems=(mtdYes,mtdNo);
  MTDTypes : Array[TMTDOptionItems] of PChar=('Auto...','Memory Technology Drivers',
             'Memory Windows');
  AutoMTDTypes : Array[TMTDOptionItems] of PChar=('Auto...','Auto (Memory Technology Drivers)',
             'Auto (Memory Windows)');

  CSTypes : Array[TCSType] of PChar=('Unknown','None','Auto-detect','Real mode',
            '16 bit protected mode mirror of real mode',
            'WARNING: P-Mode Mirror detected too late',
            '16 bit protected mode',
            '32 bit protected mode','Virtual device driver','Phoenix DLL support');


type
  TSocket=integer;

  TClientHandle=word;
  PClienthandle=^TClientHandle;

  TCardServices=Function(CSFunction : Byte; Handle : TClientHandle; NewHandle : PClientHandle;
               Buffer : Pointer; Length : word; ArgPointer : Pointer) : integer;

  TBatteryStatus=(bsGood,bsLow,bsDead,bsUnknown);

  TClientAttributeItems=(
           rcMemoryClientDriver,rcMemoryTechnologyDriver,rcIODriver,
           rcCardInsertion,rcCardInsertionExclusive,
           rcbit6,rcbit7,
           rcbit8,rcbit9,ecbit10,rbcit11,rcbit12,rcbit13,rcbit14,rcbit15);
  TClientAttributes=set of TClientAttributeItems;

  TEventMaskItems=(WriteProtect,CardLockChange,EjectionRequest,InsertionRequest,
              BatteryDead,BatteryLow,CardReady,CardDetect,
              PowerManagment,ResetEvents,SocketServices);
  TEventMask=set of TEventMaskItems;
  PEventMask=^TEventMask;

  TCardStatus=set of TEventMaskItems;
  TSocketStatus=set of TEventMaskItems;

  TClientDataBindings = record
    DI : word;               { These values are passed to the Callback }
    DS : word;               { routine in the respective registers.    }
    SI : word;               { The registration routine uses DI:SI to  }
    R  : word;               { point to the InternalClientInfoBlock    }
  end;                       { R is reserved and set to 0	             }

  TRegisterClientBlock = record
    Attributes : TClientAttributes;
    EventMask  : TEventMask;
    ClientDataBindings : TClientDataBindings;
    Version    : word;                { Min version required }
  end;

  TCSinfo = record
    InfoLen : word;
    Signature : Array[0..1] of Char;
    SocketCount : TSocket;
    Revision : word;
    CSLevel : word;
    VendorStringOffset : word;
    VendorStringLength : word;
  end;

  TCSinfoDefault = record
    InfoLen : word;
    Signature : Array[0..1] of Char;
    SocketCount : TSocket;
    Revision : word;
    CSLevel : word;
    VendorStringOffset : word;
    VendorStringLength : word;
    VendorString : Array[0..255] of char;
  end;

  { ConfigurationInfo }

  { 8 bit set }
  TwindowAttributesItems=(waSharedIO,waFirstShared,waForceAlias,wa16bitIO);
  TWindowAttributes=set of TWindowAttributesItems;

  TWindowInfo=packed record
    BasePort : word;
    Numports : Byte;
    Attributes : TWindowAttributes;
  end;

  { 16 bit set }
  TSocketAttributeItems=(saExclusivelyUsed,
                         sabit1,sabit2,sabit3,sabit44,sabit5,sabit6,sabit7,
                         saValidClient,
                         sabit9,sabit10,sabit11,sabit12,sabit13,sabit14,sabit15);
  TSocketAttributes=Set of TSocketAttributeItems;

  { 8 bit set }
  TInterfaceTypeItems=(tiMemoryOnly,tiMemoryAndIO);
  TInterfaceType=Set of TInterfaceTypeItems;

  TConfigRegistersItems=(crOption,crStatus,crPinReplacement,crSocketAndCopy);
  TConfigRegisters=set of TConfigRegistersItems;

  { 16 bit set }
  TIRQAttributesItems=(irqTimeMultiplexed,irqDynamic,{ if not either, then Exclusive }
                       irqForcePulse,irqFirstShared,
                       irqbit4,irqbit5,irqbit6,irqbit7,
                       irqPulseIRQAllocated,
                       irqbit9,irqbit10,irqbit11,irqbit12,irqbit13,ir1bit14,irqbit15);
  TIRQAttributes=set of TIRQAttributesItems;

  TConfigurationInfo=packed record
    Socket : TSocket;
    Attribute : TSocketAttributes;
    Vcc : byte;
    Vpp1 : Byte;
    Vpp2 : byte;
    IntType : TInterfacetype;
    ConfigBase : longint;
    Status : byte;
    Pin : Byte;
    Copy : Byte;
    Option : Byte;
    Present : TConfigRegisters;
    FirstDevType : Byte;
    FuncCode : Byte;
    SysInitMask : Byte;
    ManufCode : word;
    ManufInfo : word;
    CardValues : TConfigregisters;
    AssignedIRQ : byte;
    IRQAttributes : TIRQAttributes;
    Window1 : TWindowInfo;
    Window2 : TWindowInfo;
    IOAddrLines : Byte;
  end;

  TSetableConfigurationInfo=packed record
    Socket : TSocket;
    Attribute : TSocketAttributes;
    Vcc : byte;
    Vpp1 : Byte;
    Vpp2 : byte;
    IntType : TInterfacetype;
    ConfigBase : longint;
    Status : byte;
    Pin : Byte;
    Copy : Byte;
    Option : Byte;
    Present : TConfigRegisters;
  end;

  { Note no space here for name info themselves }
  { define another structure with this as a header declaring enough space }
  TClientInfo=packed record
    Case Integer of
      0: (
        MaxLen : word;
        InfoLen : word;
        Attributes : TClientAttributes;
        Revision : Word;
        CSLevel : Word;
        RevDate : word;
        NameOffset : word;
        NameLength : word;
        VendorStringOffset : word;
        VendorStringLength : word;);
      1: (Data : Array[0..0] of Char);
  end;

  PClientInfoDefault=^TClientInfoDefault;
  TClientInfoDefault=packed record
    case Integer of
      0: (
        MaxLen : word;
        InfoLen : word;
        Attributes : TClientAttributes;
        Revision : Word;
        CSLevel : Word;
        RevDate : word;
        NameOffset : word;
        NameLength : word;
        VendorStringOffset : word;
        VendorStringLength : word;);
      1: (Data : Array[0..255+20] of char;); { some space... }
  end;

  { 16 biy set }
  TOpenMemoryAttributesItems=(omAttributeMemory,omExclusive,ombit2,ombit3,ombit4,ombit5,ombit6,ombit7,
                         ombit8,ombit9,ombit10,ombit11,ombit12,ombit13,ombit14,ombit15);
  TOpenMemoryAttributes=set of TOpenmemoryAttributesItems;

  TOpenMemoryArgs=packed record
    Socket : TSocket;
    Attributes : TOpenMemoryAttributes;
    Address : longint;
  end;

  { 16 bit set }
  TWriteMemoryAttributesItems=(wmBit0,wmbit1,wmDontEraseFirst,wmVerify,
                               wmbit5,wmbit6,wmbit7,
                               wmbi8,wmbit9,wmbit10,wmbit11,wmbit12,wnbit13,wmbit14,wmbit15);
  TWriteMemoryAttributes=Set of TWriteMemoryAttributesItems;

  TWriteMemoryArgs=packed record
    Address : longint;
    Count : longint;
    Attributes : TWriteMemoryAttributes;
  end;

  TReadMemoryArgs=packed record
    Address : longint;
    Count : longint;
  end;

  { 16 bit set }
  TRequestExclusiveAttributesItems=(qebit0,qebit1,qebit2,qebit3,qebit4,qebit5,qebit6,qebit7,
                                qebit8,qebit9,qebit10,qebit11,qebut12,qebit13,qebit14,qebit15);
  TRequestExclusiveAttributes=set of TRequestExclusiveAttributesItems;

  TRequestExclusiveArgs=packed record
    Socket : TSocket;
    Attributes : TRequestExclusiveAttributes;
  end;

  TReleaseExclusiveAttributesItems=(rebit0,rebit1,rebit2,rebit3,rebit4,rebit5,rebit6,rebit7,
                                rebit8,rebit9,rebit10,rebit11,rebut12,rebit13,rebit14,rebit15);
  TReleaseExclusiveAttributes=set of TReleaseExclusiveAttributesItems;

  TReleaseExclusiveArgs=packed record
    Socket : TSocket;
    Attributes : TReleaseExclusiveAttributes;
  end;

  TValidateCISArgs=packed record
    Socket : TSocket;
    Chains : word;
  end;

  TResourceType=(rtMemory,rtIO,rtIRQ);
  { 8 bit }
  TResourceOperation=(roRemoveResource,roAddResource,roGetFirstResource,roGetNextResource);
  { 16 bit set }
  TResourceAttributesItems=(rabit0,rabit1,rabit2,rabit3,rabit4,raShared,raDirectRequest,raAllocated,
                            rabit8,rabit9,rabit10,rabit11,rabit12,rabit13,rabit14,rabit15);
  TResourceAttributes=set of TResourceAttributesItems;

  TAdjustResourceArgs=packed Record
    Action : TResourceOperation;
{    Resource : TResourceType;}
    Case Resource : TResourceType of
      rtMemory: (MEMAttributes : TResourceAttributes;
                 Address : longint;
                 Size : longint;);
      rtIO :    (BasePort : word;
                 NumPorts : Byte;
                 IOAttributes : TResourceAttributes;
                 IOAddrLines : Byte);
{      rtIRQ :   (}{SAMFIX} 
  end;

  { 16 bit set }
  TMemoryWindowAttributesItems=(mabit0,maAttributeMemory,maWindowEnableControl,
                                ma16bit,ma16KMultiple,maShare,maFirstShared,
                                maBindingSpecific,maSizeOffsets,
                                mabit9,mabit10,mabit11,mabit12,mabit13,mabit14,mabit15);
  TMemoryWindowAttributes=set of TMemoryWindowAttributesItems;

  { 8 bit set }
  TDeviceSpeed=(dsReserved0,ds250ns,ds200nds,ds150ns,ds100nds,
                dsreserved5,dsReserved6,dsreserved7);

  TMemoryAccessSpeed=packed record
    case integer of
      0: (DeviceSpeed : TDeviceSpeed);
      1: (Raw : byte);
  end;

  TRequestWindowArgs=packed Record
    Socket : TSocket;
    Attributes : TMemoryWindowAttributes;
    Address : Longint;
    Size : longint;
    AccessSpeed : TMemoryAccessSpeed;
  end;

  TMapMemPageArgs=Packed Record
    Address : longint;
    Page : byte;
  end;


const
  AllEvents = [WriteProtect,CardLockChange,EjectionRequest,InsertionRequest,
              BatteryDead,BatteryLow,CardReady,CardDetect,
              PowerManagment,ResetEvents,SocketServices];

Procedure BIOS_WChar(C : Char);
Procedure Print(S : String);
Procedure PrintZ(S : PChar; Max : integer);
Procedure Println(S : String);
Procedure PrintZln(S : PChar; Max : integer);
Function MyIntToStr(I : Integer) : String;
Procedure normalise(var segment : word; var offset : word);
Function GetError(Error : Integer) : PChar;

const
  ClientInfoSubfunction : TClientAttributes = [rcbit8,rcbit15];

{$IFDEF WINDOWS}
type
  ECSException=class(Exception)
    Error : Integer;
    Constructor Create(AnError : Integer);
    Constructor CreateMessage(AnError : Integer; Message : String);
  end;
{$ENDIF}

implementation

const
  MyErrors : Array [0..1] of PChar=(
         'Unknown error',
         'Unable to allocate buffer-buffer'
         );

  Errors : Array [0..$21] of PChar=(
         'No error',
         'Invalid adaptor',
         'Invalid attribute',
         'Invalid base system memory address',
         'Invalid EDC generator',
         'ERROR 0x05',
         'Invalid IRQ level',
         'Invalid card offset',
         'Invalid page',
         'Incomplete read request',
         'Invalid window size',
         'Invalid socket',
         'ERROR 0x0C',
         'Invalid window type',
         'Invalid VCC level',
         'Invalid Vpp1 or Vpp2 level',
         'ERROR 0x10',
         'Invalid window',
         'Incomplete write request',
         'ERROR 0x13',
         'No card present',
         'Function not supported',
         'Invalid mode',
         'Invalid speed',
         'Busy',
         'Undefined error',
         'Write protect failure',
         'Argument length invalid',
         'Argument invalid',
         'Configuration has been locked',
         'Resource in use',
         'No more of the requested items available',
         'Card services is out of resources',
         'Invalid handle');
  BadError : PChar='Unknown Error %d';

Function GetMyError(Error : Integer) : PChar;
begin
  If (Error<Low(MyErrors)) or (Error>High(MyErrors)) then
    Result:=BadError
  else
    Result:=MyErrors[Error];
end;

Function GetError;
begin
  If (Error<Low(Errors)) or (Error>High(Errors)) then
    Result:=GetMyError(-Error)
  else
    Result:=Errors[Error];
end;

Procedure BIOS_WChar(C : Char);
{ uses BIOS call to write character to screen }
{ Can be called from interrupt/callback routines }
var
  DummyC : char;

begin
  DummyC:=C;
  asm
   mov ah,$0E
   mov al,&DummyC;
   mov bh,0
   int $10
  end;
end;

Procedure Print(S : String);
{ Writes a string to the screen using bios calls.  Can be called from }
{ interrupt routines }
var
  index : byte;

begin
  for index:=1 to length(s) do
    BIOS_WChar(s[index]);
end;

Procedure PrintZ(S : PChar; Max : integer);
{ Writes a string to the screen using bios calls.  Can be called from }
{ interrupt routines }
var
  index : byte;

begin
  index:=0;
  while (s[Index]<>#0) and (index<Max) do begin
    BIOS_WChar(s[index]);
    inc(Index);
  end;
end;

procedure Println(S : String);
{ same as above but also does a NEWLINE }
begin
  Print(S);
  BIOS_WChar(#13);
  BIOS_WChar(#10);
end;

procedure PrintZln(S : PChar; Max : integer);
{ same as above but also does a NEWLINE }
begin
  PrintZ(S,Max);
  BIOS_WChar(#13);
  BIOS_WChar(#10);
end;

Function MyIntToStr;
var
  S : String[5];
begin
  Str(I,S);
  MyIntToStr:=S;
end;

procedure normalise(var segment : word; var offset : word);
begin
  segment:=segment+(offset div 16);
  offset:=offset mod 16;
end;

{$IFDEF WINDOWS}
Constructor ECSException.Create;
begin
  Inherited Create('Card Services Error: '+StrPas(GetError(AnError)));
  Error:=AnError;
end;

Constructor ECSException.CreateMessage;
begin
  Inherited Create('Card Services Error: '+StrPas(GetError(AnError))+#13+Message);
  Error:=AnError;
end;
{$ENDIF}

end.
