unit Dpmi;

interface

uses Winprocs, wintypes, sysutils;

type
  TDPMI_Reg=record
    DI : longint;
    SI : longint;
    BP : longint;
    reserved : longint;{0}
    BX : longint;
    DX : longint;
    CX : longint;
    AX : longint;
    Flags : word;
    ES : word;
    DS : Word;
    FS : Word;
    GS : Word;
    IP : Word; {Ignored}
    CS : Word; {Ignored}
    SP : Word; {Can be 0}
    SS : Word; {Can be 0}
  end;

Function GetRealModeCallback(Callback : Pointer; var CallbackDPMIReg : TDPMI_Reg) : Pointer;
Procedure ReleaseRealModeCallback(Callback : Pointer);
Function CreateAliasDescriptor(Selector : Word) : word;
Procedure SetSegmentBaseAddress(Selector : Word; BaseAddress : longint);
Procedure SetSegmentLimit(Selector : Word; Limit : longint);

implementation

uses main;

Function GetRealModeCallback;
var
  SCB, OCB, SReg, OReg : Word;
  DPMIResult : Boolean;

begin
  Log('Allocating RealMode callback');
  SCB:=HiWord(longint(Callback));
  OCB:=LoWord(longint(Callback));
  SReg:=Seg(CallbackDPMIReg);
  OReg:=Ofs(CallbackDPMIReg);
  asm
    push ds
    mov ax,SReg
    mov es,ax
    mov ax,OReg
    mov di,ax

    mov ax,SCB
    mov ds,ax
    mov ax,OCB
    mov si,ax
    mov ax,$303
    mov cx,0
    mov dx,0
    int $31
    pop ds

    mov SCB,cx
    mov OCB,dx
    mov DPMIResult,0
    jnc @@OK
    mov DPMIResult,1
    mov SCB,0
    mov OCB,0
    @@OK:
  end;
  Result:=Ptr(SCB,OCB);
  Log(Format('Got callback %p',[Result]));
end;

Procedure ReleaseRealModeCallback;
var
  SCB, OCB : Word;
  DPMIResult : Boolean;
begin
  Log(Format('Releaseing RealMode callback %p',[Callback]));
  SCB:=HiWord(Longint(Callback));
  OCB:=LoWord(Longint(Callback));
  asm
    mov ax,$304
    mov cx,SCB
    mov dx,OCB
    int $31
  end;
end;

Function CreateAliasDescriptor; assembler;
asm
  mov ax,$0A
  mov bx,Selector
  int $31
  jnc @ok
  mov ax,0
  @ok:
end;

Procedure SetSegmentBaseAddress;
begin
  asm
    mov ax,$7
    mov bx,Selector
    mov cx,Baseaddress.longrec.hi
    mov dx,Baseaddress.longrec.lo
    int $31
  end;
end;

Procedure SetSegmentLimit;
begin
  asm
    mov ax,$8
    mov bx,Selector
    mov cx,Limit.longrec.hi
    mov dx,Limit.longrec.lo
    int $31
  end;
end;

end.
