unit intrs;

interface

uses  sysutils;

type
  TRegxisters=Record
    case integer of
      0: (AX, BX, CX, DX, SI, DI, ES, Flags : Word);
      1: (AL, AH, BL, BH, CL, CH, DL, DH: Byte);
      2: (xAX, xBX, xCX, xDX, xSI, xDI, xES, xFlags : Word);
  end;

Procedure CSIntr(var Reg : TRegisters);

implementation
var
  s, o : word;

Procedure CSIntr;
begin
  s:=seg(reg);
  o:=ofs(reg);

  asm
    push ds

    mov si, o
    mov ds, s { ds:si is now pointing to the REG structure }
              { we have also lost ds }
    lodsw
    push ax { ax }
    lodsw
    mov bx, ax
    lodsw
    mov cx, ax
    lodsw
    mov dx, ax
    lodsw
    push ax { si is being used }
    lodsw
    mov di, ax
    lodsw
    mov es, ax

    pop si
    pop ax { get back old ax }
    mov ah, $AF
    { CALL INTERRUPT }
    int $1A

    pop ds { we could've popped this before the int }
    pushf
    push es
    push di

    mov es, s
    mov di, o

    stosw
    mov ax, bx
    stosw
    mov ax, cx
    stosw
    mov ax, dx
    stosw
    mov ax, si
    stosw
    pop ax { get di }
    stosw
    pop ax { get es }
    stosw
    pop ax { flags }
    stosw
  end;
end;

(*
procedure Intr(IntNo: Byte; var Regs: TRegisters); assembler;
asm
	PUSH	DS
{$IFDEF ProtectedMode}
{$IFDEF Windows}
	PUSH	CS
	CALL	AllocCSToDSAlias
{$ELSE}
	MOV	AX,CS
	ADD	AX,SelectorInc
{$ENDIF} { ANY protected mode, self modify }
	MOV	DS,AX
	CLI
	PUSH	WORD PTR DS:@@Int
	PUSH	DS
	MOV	AL,IntNo
	MOV	BYTE PTR DS:@@Int+1,AL
{$ELSE} { not protected mode, self modify }
	PUSH	WORD PTR CS:@@Int
	MOV	AL,IntNo
	MOV	BYTE PTR CS:@@Int+1,AL
{$ENDIF}
	PUSH	BP			{ Preserve our BP }
	LDS	SI,Regs
	CLD
	LODSW
	PUSH	AX			{ Regs.AX }
	LODSW
	XCHG	AX,BX
	LODSW
	XCHG	AX,CX
	LODSW
	XCHG	AX,DX
	LODSW
	XCHG	AX,BP
	LODSW
	PUSH	AX			{ Regs.SI }
	LODSW
	XCHG	AX,DI
	LODSW
	PUSH	AX			{ Regs.DS }
	LODSW
{$IFDEF DPMI}
        VERR    AX
	JNZ	@@1
	MOV	ES,AX
@@1:	POP	AX			{ Regs.DS }
	VERR	AX
	JNZ	@@2
	MOV	DS,AX
@@2:
{$ELSE}
	MOV	ES,AX
	POP	DS			{ Regs.DS }
{$ENDIF}
	POP	SI			{ Regs.SI }
	POP	AX			{ Regs.AX }
@@Int:	INT	0
	STI
	PUSHF				{ New Regs.Flags, .ES, .DI, .BP }
	PUSH	ES
	PUSH	DI
	PUSH	BP
	MOV	BP,SP
	MOV	BP,[BP+8]		{ Recover our BP }
	LES	DI,Regs
	CLD
	STOSW
	XCHG	AX,BX
	STOSW
	XCHG	AX,CX
	STOSW
	XCHG	AX,DX
	STOSW
	POP	AX			{ New Regs.BP }
	STOSW
	XCHG	AX,SI
	STOSW
	POP	AX			{ New Regs.DI }
	STOSW
	MOV	AX,DS
	STOSW
	POP	AX			{ New Regs.ES }
	STOSW
	POP	AX			{ New Regs.Flags }
	STOSW
	POP	AX			{ Throw away our pushed BP }
{$IFDEF ProtectedMode}
	POP	DS
	POP	WORD PTR DS:@@Int
{$ELSE}
	POP	WORD PTR CS:@@Int
{$ENDIF}
{$IFDEF Windows}
	MOV	AX,DS
	POP	DS
	PUSH	AX
	CALL	FreeSelector
{$ELSE}
	POP	DS
{$ENDIF}
end;
*)
end.

