{NOTED}
{ This unit contains ONLY things retuied for the CSM library }

Unit smctypes;

interface

uses sysutils;

const
  MinPhysicalWindowSize = 4096;
  PhysicalWindowSize = MinPhysicalWindowSize * 2;
  { so that we can always have our 2K enclised within 8K on a 4K boundry }
  { a HACK but there we go... }

type
  TFileType = (Ascii,Comma,AsStored,None);

   PFname = ^TFName;
   TFName = TFileName;

  PCSMDisplayPointer = ^ TCSMDisplayPointer;
  TCSMDisplayPointer = longint;

  TCardItem =word;

  const
    Eventbuffer_size=502;
    NAVSize = 255;                  { See the type below for explanations }
    ICIB_BLen = 20;                 { size of block before vendor strings }

  const
    windowbuffer_size = 2048;
    { This must be the same size as the blockbuffer in SMCCOLLD.PAS }
    { i.e. it is 1048 words, we must be 2048 bytes }
    { if not used in SMCREAD then it can be any multiple of 2 but
       be less than 16K }

  type
    PWindowBuffer = ^ TWindowBuffer;
    Twindowbuffer = array [0..(windowbuffer_size - 1)] of byte;
    { Generally used as a buffer for copying to and from the card }
    { Most routines use this as the buffer type }

    PPtr3 = ^TPtr3;
    TPtr3 = record                   { An easy way of breaking up James   }
      LSB : byte;		     { 3 byte pointers for the CSM        }
      SB  : byte;                    { This is CSM Specific and shouldn't }
      MSB : byte;                    { Be in this file, FIX               }
      end;

    PCSMPage0 = ^TCSMPage0;
    PCardWord = ^TCardWord;

    TCardWord = array [0..((windowbuffer_size -1) div 2)] of word;
    { To allow a way of accessing the card buffer in word context    }

    TCSMPAge0 = record    { A way of accessing the card buffer in }
			      { context of being page0 on a CSM card  }
			      { This is CSM specific and should be    }
			      { somewhere else.  FIX                  }
      CSLTag : array [0..2] of char;  { Should be set to 'CSL'        }
      BlockCount : Byte;              { Number of 16K blocks on card-1}
      Flags1 : byte;                  { See CSM notes		      }
      ErrorCount : byte;
      ASL : TPtr3;
      SRP1 : TPtr3;
      DLP : TPtr3;		      { Not used }
      DP : TPtr3;
      CardFormat : byte;              { Always 1 }
      Prog1 : TPtr3;
      Prog2 : TPtr3;
      Prog3 : TPtr3;
      Prog4 : TPtr3;
      Prog5 : TPtr3;
      Prog6 : TPtr3;
      Prog7 : TPtr3;
      Prog8 : TPtr3;
      Flags2 : Byte;
      SRP2 : TPtr3;
      OldFileMark : TPtr3;
      NewFileMark : TPtr3;
      CheckByte : byte;
      DummyByte : Byte;
      end;

{ These two should both be in another file FIX }
{ They cast to and from james 3 byte pointers }
procedure ASPtr3( var ThePtr : TPtr3; Lint : Longword);
function FROMPtr3( ThePtr : TPtr3) : longword;
function Aver(s : string) : string; {formats the 4 char versopn strings with a . }

implementation

{ Writes the LS3bytes of Lint to ThePtr }
procedure ASPtr3( var ThePtr : TPtr3; Lint : Longword);
begin
  ThePtr.LSB:=byte(Lint);
  ThePtr.SB:=byte(Lint shr 8);
  ThePtr.MSB:=byte(Lint shr 16);
end;

{ Turns ThePtr as longword }
function FROMPtr3( ThePtr : TPtr3) : longword;
begin
  FROMPtr3:=ThePtr.LSB+(longint(ThePtr.SB) * 256)+(longint(ThePtr.MSB) * 65536);
end;

Function AVer;
begin
  Aver:=Copy(s,1,2)+'.'+copy(s,3,2);
end;

end.

