unit Utils;

interface

uses classes, Winprocs, sysutils;

Procedure CopyFile(const Source, Dest : String);

Function backup(const Filename : String) : String;

function validselector(selector : word) : boolean;
Function Compare(var Source, Dest; Size : word) : Boolean;
Function Min(a, b : longint) : longint;

{ Protreal is an address.  We need to return in RealReal a real mode segment }
{ with Size SIZE, where RealReal is ALSO a ProtProt selector pointing to }
{ the same memory as ProtProt pointer }
{ Boo: Can't do this as AllocateSpecificLDTDescriptor is limited to below $80 }
{Function GetSelectorSegmentMatchingPair(Var RealReal, ProtReal : integer;
          Size : Integer; ProtProt : Pointer) : Boolean;
Procedure FreeSelectorSegmentMatchingPair(RealReal, ProtReal : integer);
}
implementation

{ cheap copy for small files }
Procedure CopyFile;
var
  S, D : TFileStream;
  B : Array[0..1023] of byte;
  C : longint;
begin
  S:=TFileStream.Create(Source,fmOpenRead);
  try
    D:=TFileStream.Create(Dest,fmCreate);
    try
      repeat
        c:=S.Read(B,SizeOf(B));
        D.Write(B,C);
      until c=0;
    finally
      D.Free;
    end;
  finally
    S.Free;
  end;
end;

{ copies a file like: filename.fil to filename.000 or filename.001 etc etc }
{ returns the backup name }
Function backup;
var
  Path : String;
  c : integer;
  i : Integer;
  SearchRec : TSearchRec;
  Ext : String[4];
begin
  Path:=Filename;
  { replace extention with * }
  c:=0;
  i:=length(path);
  while (i>0) and (c<=3) do begin
    If Path[i]='.' then begin
      Path:=Copy(Path,1,i)+'*'; break;
    end;
    inc(c);
    dec(i);
  end;
  Result:='';
  c:=0;
  try
    If FindFirst(Path,faAnyFile,SearchRec)=0 then begin
      repeat
        Ext:=Copy(ExtractFileExt(Searchrec.name),2,255);
        I:=StrToIntDef(ext,-1)+1;
        If I>c then c:=I;
      until FindNext(SearchRec)<>0;
      { c contains current count... }
      If c>=1000 then
        Ext:='CSL'
      else
        Ext:=Format('%3.3d',[c]);
      { now plug in }
      Path:=Copy(Path,1,length(path)-1)+Ext;
      { now copy filename to path }
      CopyFile(Filename,Path);
      Result:=Path;
    end;
  finally
    FindClose(SearchRec);
  end;
end;

function validselector(selector : word) : boolean;
var
  tw : word;
begin
  tw:=AllocDSToCSAlias(selector);
  FreeSelector(tw);
  result:=tw<>0;
end;

Function Compare; assembler;
asm
  push ds
  lds si,Source
  les di,Dest
  mov cx,Size
  repz
  cmpsb
  mov ax,0
  jnz @end
  mov ax,1
{  jmp @end
  @bad:
  mov ax,0}
  @end:
  pop ds
end;

function Min;
begin
  If A<B then
    Result:=A
  else
    Result:=B;
end;

(*
Function AllocateSpecificLDTSelector(Selector : Integer) : Boolean;
begin
  asm
    push bp
    push ds
    mov ax,$d
    mov bx,Selector
    int $31
    mov @result,1
    jnc @ok
    cmp ax,$d
    jz @ok
    mov @result,0
    @ok:
    pop ds
    pop bp
  end;
end;

Function FreeLDTDescriptor(Selector : Word) : Boolean;
begin
  asm
    push bp
    push ds
    mov ax,1
    mov bx,Selector
    int $31
    mov @result,1
    jnc @ok
    mov @result,0
    @ok:
    pop ds
    pop bp
  end;
end;
(*
Function GetSelectorSegmentMatchingPair;
var
  Address : longint;
  ProtProtBase : longint;
  OK : Boolean;
  DOSAllocs : TList;
  C : Integer;
  Dummy : integer;
  Error : Boolean;
begin
  { Keep allocating real mode memory until we can map a selector same }
  { a paragraph address, then alloc win memory of same size, and map }
  { selector to win memory, then free other memories }
  Result:=False;
  DOSAllocs:=TList.Create;
  OK:=False;
  try
    c:=0;
    repeat
      inc(c);
      Address:=GlobalDosAlloc(Size);
      If Address=0 then
        break;
      ProtReal:=LoWord(Address);
      RealReal:=HiWord(Address);
      try
        Error:=False;
        Dummy:=PInteger(Ptr(RealReal,0))^;
      except
        Error:=True;
      end;
      If Error then OK:=AllocateSpecificLDTSelector(RealReal);
      { SAMFIX TEST: Dereference selector to see if it worked..? }
      { add for free'ing later }
      If not OK then DOSAllocs.Add(pointer(longint(ProtReal)));
    Until OK or (c>10);
    { if not OK then couldn't do it... }
    If OK then begin
      { make this LDTSelector point to some real ram }
      ProtProtBase:=GetSelectorBase(Seg(ProtProt^));
      { Remember RealReal is also a form of ProtProt now... }
      OK:=OK and (SetSelectorBase(RealReal,ProtProtBase)<>0);
      SetSelectorLimit(RealReal,Size);
      If OK then begin { test again }
        try
          Error:=False;
          Dummy:=PInteger(Ptr(RealReal,0))^;
        except
          Error:=True;
        end;
        If Error then OK:=False;
      end;
      Result:=OK;
    end;
  finally
    { free previous DOS alloc's }
    For c:=0 to DOSAllocs.Count-1 do begin
      GlobalDosFree(longint(DOSAllocs[c]));
    end;
    DOSAllocs.Free;
  end;
end;

Procedure FreeSelectorSegmentMatchingPair;
begin
  { Do a global dos Free on RealReal and also a FreeLDTDescriptor }
  { as RealReal is also a ProtProt }
  GlobalDOSFree(ProtReal);
  FreeLDTDescriptor(RealReal);
end;
  *)
end.
