/******************************************************************/
/*  		                                                       	*/
/*  	File      : cstypes.h                                  		*/
/*                                                                */
/*    Function  : Samuel Liddicott card service DLL					*/
/*                                                                */
/*                                                                */
/*     Date     : Rev : Author           									*/
/*    ----------+-----+---------------------------------------    */
/*     21.08.97 : 1.1 : Dietmar Ortler                            */
/*                                                                */
/******************************************************************/

#ifndef __CSLCS_H
#define __CSLCS_H

// *********************
// CSL_CS:DLL used now *
// *********************

#define CSLCSDLL "CSL_CS.DLL"		// name of Sam Liddicott DLL

// *************************
// used functions from DLL *
// *************************

typedef WORD (FAR PASCAL *LPFNCARDSERVICES)
	(  BYTE cCSFunction,                         // card service function
		int  iHandle,                             // client handle from RegisterClient
		WORD FAR *pNewHandle,                     // new handle from CS
		char FAR *pBuffer,                        // supplementary data
		WORD iLength,                             // length of argument data
		char FAR *pArgPointer                     // argument data
	);
#define CSL_CardServices (*lpfnCardServices)

typedef void (FAR PASCAL *LPFNDEFAULTCALLBACK)
	(  WORD FAR *pFlags,
		WORD iAX,
		WORD iBX,
		WORD iCX,
		WORD iDX,
		WORD iSI,
		WORD iDI,
		WORD iDS,
		WORD iES,
		WORD iBP
	);
#define CSL_DefaultCallBack (*lpfnDefaultCallBack)

typedef BOOL (FAR PASCAL *LPFNDEREGISTERCLIENT)
	( 	int iHandle,      								// client handle from RegisterClient
		WORD FAR *pError									// error code :
					// BAD_ARG_LENGTH, BAD_HANDLE, BUSY, IN_USE
	);
#define CSL_DeRegisterClient (*lpfnDeRegisterClient)

typedef BOOL (FAR PASCAL *LPFNGETCARDSERVICESINFO)
	( 	struct tagCSInfo FAR *pCSInfo,    			// card service info
		WORD iSize,       								// size of card service info structure
		WORD FAR *pError  								// error code :
					// BAD_ARG_LENGTH, UNSUPPORTED_FUNCTION
	);
#define CSL_GetCardServicesInfo (*lpfnGetCardServicesInfo)

typedef BOOL (FAR PASCAL *LPFNGETCARDSERVICESINFODEFAULT)
	( 	struct tagCSInfo FAR *pCSInfo, 				// card service info
		WORD FAR *pError									// error code :
					// BAD_ARG_LENGTH, UNSUPPORTED_FUNCTION
	);
#define CSL_GetCardServicesInfoDefault (*lpfnGetCardServicesInfoDefault)

typedef BOOL (FAR PASCAL *LPFNREGISTERCLIENT)
	( 	LPINT pNewHandle,									// handle returned by CS
		UINT iU_Attributes,								// driver and event information
		UINT iU_Events,									// event notify information
		WORD iU_Version,  								// card service level
		struct tagPascalString FAR *pU_ClientName,// client name
		struct tagPascalString FAR *pU_VendorName,// vendor name
		WORD iU_Revision,									// card service revision
		WORD iU_Date,     								// current date in encrypted form
		void FAR *pCallback,                      // callback procedure
		WORD iDI,         								// window handle for event notification
		WORD iDS,         								// segment of client's data area
		WORD iSI,         								// reference data return to client for event notification
		WORD FAR *pError  								// error code :
					// BAD_ARG_LENGTH, BAD_ATTRIBUTE, BAD_VERSION, OUT_OF_RESOURCE
	);
#define CSL_RegisterClient (*lpfnRegisterClient)

typedef BOOL (FAR PASCAL *LPFNRELEASECONFIGURATION)
	(  int iHandle,                              // client handle from RegisterClient
		int iSocket,                              // logical socket number
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_ADAPTER, BAD_SOCKET
	);
#define CSL_ReleaseConfiguration (*lpfnReleaseConfiguration)

typedef BOOL (FAR PASCAL *LPFNRELEASEWINDOW)
	(  int iWinHandle,                           // window handle
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_HANDLE
	);
#define CSL_ReleaseWindow (*lpfnReleaseWindow)

typedef BOOL (FAR PASCAL *LPFNREQUESTCONFIGURATION)
	(  int iHandle,                              // client handle from RegisterClient
		struct tagSetableConfigurationInfo FAR *pConfigurationInfo,	// configuration info
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_ATTRIBUTE, BAD_HANDLE, BAD_TYPE,
					// BAD_SOCKET, BAD_VCC, BAD_VPP, CONFIGURATION_LOCKED, NO_CARD, IN_USE
	);
#define CSL_RequestConfiguration (*lpfnRequestConfiguration)

// ************************************************************************
// checked functions which cause problems in earlier revisions of the DLL *
// ************************************************************************

typedef BOOL (FAR PASCAL *LPFNGETCONFIGURATIONINFO)
	(  int iSocket,      								// logical socket number
		int iHandle,                              // client handle from RegisterClient
		struct tagConfigurationInfo FAR *pCfgInfo,// configuration info
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_SOCKET, NO_CARD
	);
#define CSL_GetConfigurationInfo (*lpfnGetConfigurationInfo)

typedef BOOL (FAR PASCAL *LPFNREQUESTWINDOW)
	(  int  iHandle,                             // client handle from RegisterClient
		WORD FAR *pWinHandle,                     // returned window handle
		int  iSocket,                             // logical socket number
		UINT FAR *pAttributes,  						// memory attributes
		char FAR *pBaseAddress,              		// system base address
		LONG FAR *pSize,                          // memory window size
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_ATTRIBUTE, BAD_BASE, BAD_HANDLE, BAD_SIZE,
					// BAD_SOCKET, BAD_SPEED, NO_CARD, OUT_OF_RESOURCE, IN_USE
	);
#define CSL_RequestWindow (*lpfnRequestWindow)

// ***************************************************
// functions only converted from PASCAL, not checked *
// ***************************************************

typedef WORD (FAR PASCAL *LPFNALLSTYLES)
	(
	);
#define CSL_AllStyles (*lpfnAllStyles)

typedef BOOL (FAR PASCAL *LPFNCARDPRESENT)
	(  int iSocket                               // logical socket number
	);
#define CSL_CardPresent (*lpfnCardPresent)

typedef BYTE (FAR PASCAL *LPFNCHECKBATTERY)
	(  int iSocket                               // logical socket number
	);
#define CSL_CheckBattery (*lpfnCheckBattery)

typedef WORD (FAR PASCAL *LPFNCHECKINSTALLATION)
	(	UINT iCSType                   				// type of card service
	);
#define CSL_CheckInstallation (*lpfnCheckInstallation)

typedef BOOL (FAR PASCAL *LPFNCHECKVERSION)
	(	WORD iVersion                             // card service version
	);
#define CSL_CheckVersion (*lpfnCheckVersion)

typedef char FAR * (FAR PASCAL *LPFNDLLINFO)
	(
	);
#define CSL_DLL_Info (*lpfnDLL_Info)

typedef LONG (FAR PASCAL *LPFNDLLVERSION)
	(
	);
#define CSL_DLL_Version (*lpfnDLL_Version)

typedef BOOL (FAR PASCAL *LPFNFINDRESOURCE)
	(  int  iHandle,                             // client handle from RegisterClient
		BYTE cResourceType,								// resource type
		UINT iAttributes,									// memory attributes
		char FAR *pBaseAddress,              		// system base address
		LONG lSize,                               // memory window size
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_ATTRIBUTE, BAD_BASE, BAD_SIZE,
					// OUT_OF_RESOURCE, IN_USE, NO_MORE_ITEMS, UNSUPPORTED_SERVICE
	);
#define CSL_FindResource (*lpfnFindResource)

typedef BOOL (FAR PASCAL *LPFNGETCLIENTINFO)
	( 	int iHandle,     									// client handle from RegisterClient
		struct tagClientInfo FAR *pClientInfo,		// client info
		WORD iSize,       								// size of client info structure
		WORD FAR *pError  								// error code :
					// BAD_ARG_LENGTH, BAD_HANDLE
	);
#define CSL_GetClientInfo (*lpfnGetClientInfo)

typedef BOOL (FAR PASCAL *LPFNGETCLIENTINFODEFAULT)
	( 	int iHandle,      							 	// client handle from RegisterClient
		struct tagClientInfo FAR *pClientInfo,		// client info
		WORD FAR *pError  								// error code :
					// BAD_ARG_LENGTH, BAD_HANDLE
	);
#define CSL_GetClientInfoDefault (*lpfnGetClientInfoDefault)

typedef BOOL (FAR PASCAL *LPFNGETFIRSTCLIENT)
	(  LPINT iHandle,                            // client handle returned from CS
		int iSocket,                              // logical socket number
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_SOCKET, NO_MORE_ITEMS, NO_CARD
	);
#define CSL_GetFirstClient (*lpfnGetFirstClient)

typedef BOOL (FAR PASCAL *LPFNGETSTATUS)
	( 	WORD  iSocket,     								// logical socket number
		LPINT pCardStatus, 								// card state information
		LPINT pSocketStatus,								// socket state information
		WORD FAR *pError  								// error code :
					// BAD_ARG_LENGTH, BAD_SOCKET
	);
#define CSL_GetStatus (*lpfnGetStatus)

typedef WORD (FAR PASCAL *LPFNMAPCARDSERVICES)
	(  UINT iCSType,                  				// type of card service
		BYTE cCSFunction,                         // card service function
		int  iHandle,                             // client handle from RegisterClient
		WORD FAR *pNewHandle,                     // new handle from CS
		char FAR *pBuffer,                        // supplementary data
		WORD iLength,                             // length of argument data
		char FAR *pArgPointer                     // argument data
	);
#define CSL_MapCardServices (*lpfnMapCardServices)

typedef BOOL (FAR PASCAL *LPFNMAPMEMPAGE)
	(  int  iWinHandle,                          // window handle
		char FAR *pAddress,                       // card offset address
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_ADAPTER, BAD_SOCKET
	);
#define CSL_MapMemPage (*lpfnMapMemPage)

typedef BOOL (FAR PASCAL *LPFNRELEASEEXCLUSIVEACCESS)
	(  int  iHandle,                             // client handle from RegisterClient
		int  iSocket,                             // logical socket number
		UINT iAttributes,									// reserved
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_HANDLE, BAD_SOCKET
	);
#define CSL_ReleaseExclusiveAccess (*lpfnReleaseExclusiveAccess)

typedef BOOL (FAR PASCAL *LPFNREQUESTEXCLUSIVEACCESS)
	(  int  iHandle,                             // client handle from RegisterClient
		int  iSocket,                             // logical socket number
		UINT iAttributes,									// reserved
		WORD FAR *pError                          // error code :
					// BAD_ARG_LENGTH, BAD_HANDLE, BAD_SOCKET, IN_USE, NO_CARD
	);
#define CSL_RequestExclusiveAccess (*lpfnRequestExclusiveAccess)

typedef BOOL (FAR PASCAL *LPFNRUNSETUP)
	(
	);
#define CSL_RunSetup (*lpfnRunSetup)

typedef void (FAR PASCAL *LPFNSEARCHINSTALLATION)
	(	UINT iCSType,                  				// type of card service
		WORD FAR *pDetected
	);
#define CSL_SearchInstallation (*lpfnSearchInstallation)

typedef BOOL (FAR PASCAL *LPFNSETEVENTMASK)
	( 	int  iHandle,      								// client handle from RegisterClient
		UINT iEventMask,					          	// event mask information
		WORD FAR *pError  								// error code :
					// BAD_ARG_LENGTH, BAD_HANDLE, BAD_SOCKET, NO_CARD
	);
#define CSL_SetEventMask (*lpfnSetEventMask)

typedef WORD (FAR PASCAL *LPFNSOCKETCOUNT)
	(
	);
#define CSL_SocketCount (*lpfnSocketCount)

typedef WORD (FAR PASCAL *LPFNSTYLE)
	(
	);
#define CSL_Style (*lpfnStyle)

typedef BOOL (FAR PASCAL *LPFNVALIDATECIS)
	(  int  iSocket,                             // logical socket number
		WORD FAR *pCount,                         // number of chains
		WORD FAR *pError                          // error code :
      			// BAD_ARG_LENGTH, BAD_SOCKET, NO_CARD
	);
#define CSL_ValidateCIS (*lpfnValidateCIS)

// client attributes
#define rcMemoryClientDriver 			0x0001
#define rcMemoryTechnologyDriver		0x0002
#define rcIODriver						0x0004
#define rcCardInsertion					0x0008
#define rcCardInsertionExclusive		0x0010

// event mask
#define emWriteProtect		 			0x0001
#define emCardLockChange	 			0x0002
#define emEjectionRequest	 			0x0004
#define emInsertionRequest				0x0008
#define emBatteryDead		 			0x0010
#define emBatteryLow						0x0020
#define emCardReady			 			0x0040
#define emCardDetect						0x0080
#define emPowerManagment	 			0x0100
#define emResetEvents		 			0x0200
#define emSocketServices	 			0x0400

// socket attributes
#define saExclusivelyUsed				0x0001
#define saValidClient					0x0100

// IRQ attributes
#define irqTimeMultiplexed				0x0001
#define irqDynamic						0x0002
#define irqForcePulse					0x0004
#define irqFirstShared					0x0008
#define irqPulseIRQAllocated			0x0100

// memory window attributes
#define maAttributeMemory				0x0002
#define maWindowEnableControl			0x0004
#define ma16bit							0x0008
#define ma16KMultiple					0x0010
#define maShare							0x0020
#define maFirstShared					0x0040
#define maBindingSpecific				0x0080
#define maSizeOffsets					0x0100

// card socket types
#define csUnknown							0x0001
#define csNone								0x0002
#define csAuto								0x0004
#define csRealMode						0x0008
#define csRealProt16						0x0010
#define csBadRealProt16					0x0020
#define csProt16							0x0040
#define csProt32							0x0080
#define csVXD								0x0100
#define csPhoenix							0x0200

// resource attributes
#define raShared							0x0020
#define raDirectRequest					0x0040
#define raAllocated						0x0080

// string format in PASCAL

struct tagPascalString
	{	BYTE	cLength;                   // length of string
		char  szString[256];					// content of string
	};

// card service info

struct tagCSInfo
	{ 	WORD	iInfoLen;    					// length of data returned by CS
		char	aSignature[2]; 				// CS if card service installed
		WORD	iSocketCount;              // number of sockets
		WORD	iRevision;                 // vendor's card service revision
		WORD	iCSLevel;                  // card service release
		WORD	iVendorStringOffset;       // offset to vendor string
		WORD	iVendorStringLength;       // length of vendor string
		WORD	iNumOfFunctionPerSocket;   // maximum number of functions per socket
		char	szVendorString[256];       // ASCII vendor string
	};

// configuration info

struct tagConfigurationInfo
	{	int	iSocket;                   // logical socket
		UINT	iAttribute;						// socket information
		BYTE	cVcc;                      // VCC setting
		BYTE	cVpp1;                     // VPP1 setting
		BYTE	cVpp2;                     // VPP2 setting
		BYTE	cIntType;                  // interface type
		LONG 	lConfigBase;               // base address of configuration registers
		BYTE	cStatus;                   // card status register setting
		BYTE	cPin;                      // card pin register setting
		BYTE	cCopy;                     // card socket/copy register setting
		BYTE	cOption;                   // card option register setting
		BYTE	cPresent;                  // card configuration registers present
		BYTE	cFirstDevType;             // from device ID tuple
		BYTE	cFuncCode;                 // from function ID tuple
		BYTE	cSysInitMask;              // from function ID tuple
		WORD	iManufCode;                // from manufacturer ID tuple
		WORD	iManufInfo;                // from manufacturer ID tuple
		BYTE	cCardValues;               // valid card register values
		BYTE	cAssignedIRQ;              // IRQ assigned to PC card
		UINT	iIRQAttributes;  				// IRQ information
		WORD	iBasePort1;                // base address of port 1
		BYTE	cNumPorts1;                // number of contigous ports
		BYTE	cAttributes1;              // port attributes
		WORD	iBasePort2;                // base address of port 2
		BYTE	cNumPorts2;                // number of contigous ports
		BYTE	cAttributes2;              // port attributes
		BYTE	cIOAddrLines;              // number of I/O address lines
	};

// client info

struct tagClientInfo
	{ 	WORD 	iMaxLen;                   // length of this packet
		WORD 	iInfoLen;                  // length of info returned by client
		UINT 	iClientAttributes;  			// driver and event information
		WORD 	iRevision;                 // vendor client revision
		WORD 	iCSLevel;                  // card service release
		WORD 	iRevDate;                  // revision date
		WORD 	iNameOffset;               // offset to client name string
		WORD 	iNameLength;               // length of client name
		WORD 	iVendorStringOffset;       // offset to vendor string
		WORD 	iVendorStringLength;       // length of vendor string
		char 	szData[276];               // client name and vendor string
	};

// configuration info to be set

struct tagSetableConfigurationInfo
	{ 	int	iSocket;                   // logical socket
		UINT	iAttribute;   					// socket information
		BYTE	cVcc;                      // VCC setting
		BYTE	cVpp1;                     // VPP1 setting
		BYTE	cVpp2;                     // VPP2 setting
		BYTE	cIntType;                  // interface type
		char  FAR *pConfigBase;          // card base address of configuration registers
		BYTE	cStatus;                   // card status register setting
		BYTE	cPin;                      // card pin register setting
		BYTE	cCopy;                     // card socket/copy register setting
		BYTE	cOption;                   // card option register setting
		BYTE	cPresent;                  // card configuration registers present
	};

#endif // ifdef _CSLCS_H

