unit First;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, clients, modify, ExtCtrls, IniFiles,
  cstypes2, toolhelp;

type
  TFirstForm = class(TForm)
    Label1: TLabel;
    Notebook1: TNotebook;
    Express: TRadioButton;
    Custom: TRadioButton;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    DoneButton: TBitBtn;
    Changes: TMemo;
    Label6: TLabel;
    Label7: TLabel;
    BitBtn3: TBitBtn;
    PCNone: TRadioButton;
    Label8: TLabel;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label12: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure DoneButtonClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure Label8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure Log(text : string);
    Procedure StartUp;
  end;

  Function WantSetup : Boolean;
  Procedure SetType(CSType : TCSType);

var
  FirstForm: TFirstForm;

implementation

{$R *.DFM}

Procedure SetType(CSType : TCSType);
var
  IniFile : TIniFile;
begin
  iniFile:=TIniFile.Create('CSL_CS.INI');
  IniFile.WriteInteger('Options','CardServicesType',integer(csType));
  IniFile.Free;
end;

Function WantSetup;
var
  User : Word;
begin
  Result:=True;
end;

procedure TFirstForm.BitBtn1Click(Sender: TObject);
begin
  try
    If PCNone.Checked then
      SetType(csNone)
    else begin
      Application.CreateForm(TSetup, Setup);
      Application.CreateForm(TExtraDrivers, ExtraDrivers);
      If not Express.Checked then
    {    Visible:=False};
      Notebook1.PageIndex:=Notebook1.PageIndex+1;
{      If not Express.Checked then FormStyle:=fsNormal;}
      try
        Setup.Go(Express.Checked);
      except
        on e: exception do begin
          Application.ShowException(E);
          MessageDlg('An error occurred during setup. Your PCCard setup may not be correct.',
                     mtError,[mbOK],0);
        end;
      end;
    end;
  finally
    DoneButton.Enabled:=True;
    If Changes.Lines.Count=0 then Log('No changes were made.');
  end;
end;

procedure TFirstForm.BitBtn2Click(Sender: TObject);
begin
  If MessageDlg('Your PCCard setup may not be correct.  Quit anyway?',mtWarning,[mbyes,mbNo],0)=mrYes then
    Close;
end;

procedure TFirstForm.DoneButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TFirstForm.Log;
begin
  Changes.Lines.Add('* '+text);
  Changes.Lines.Add('');
end;

procedure TFirstForm.BitBtn3Click(Sender: TObject);
begin
  Application.helpContext((Sender as TWinControl).HelpContext);
end;

procedure TFirstForm.BitBtn4Click(Sender: TObject);
begin
  NoteBook1.PageIndex:=NoteBook1.PageIndex+1;
end;

procedure TFirstForm.BitBtn7Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFirstForm.BitBtn5Click(Sender: TObject);
begin
  SetType(csNone);
  Application.Terminate;
end;

procedure TFirstForm.BitBtn6Click(Sender: TObject);
begin
  Application.HelpContext(10);
end;

Procedure TFirstForm.Startup;
var
  TaskInfo : TTaskEntry;
  TaskParent : THandle;
  C : Integer;

  Procedure SneakYield;
  var
    MSG : TMSG;
  begin
    PeekMessage(MSG,0,$FFFF,$FFFF,PM_NoRemove);
  end;

begin
  If not ((ParamCount<>0) and (ParamStr(1)='auto')) then begin
    FirstForm.NoteBook1.PageIndex:=FirstForm.NoteBook1.PageIndex+1;
  end else begin
    { this gets just a little complicated }
    { we can be sure that the program that started us, hasn't finished loading yet }
    { and probably hasn't even started its main form.... }
    { we don't want to run until it has got started! }
    TaskInfo.dwSize:=SizeOf(TaskInfo);
    If TaskFindHandle(@TaskInfo,GetCurrentTask) then begin
      TaskParent:=TaskInfo.hTaskParent;
      { now we blockuntil the parent has its main window active for a short while.... }
      { why not send a dummy message to it and then block until is message queue is empty... }
      { actually... all we need it a few quick yields so IT gets control and finished loading... }
      { 10 yields should be plenty! }
      For c:=0 to 10 do
        SneakYield;
    end;
  end;
end;

procedure TFirstForm.FormCreate(Sender: TObject);
begin
  StartUp;
end;

procedure TFirstForm.Label7Click(Sender: TObject);
begin
  Custom.SetFocus;
  Custom.Checked:=True;
end;

procedure TFirstForm.Label6Click(Sender: TObject);
begin
  Express.SetFocus;
  Express.Checked:=True;
end;

procedure TFirstForm.Label8Click(Sender: TObject);
begin
  PCNone.SetFocus;
  PCNone.Checked:=True;
end;

end.
