unit Modify;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, TabNotBk, windos, Buttons, utils;

type
  TExtraDrivers = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    GroupBox1: TGroupBox;
    Configsys: TListBox;
    ConfigDrivers: TListBox;
    Label2: TLabel;
    autoexec: TListBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    AutoexecDrivers: TListBox;
    AutoExecSource: TLabel;
    ConfigSource: TLabel;
    SConfig: TBitBtn;
    CConfig: TBitBtn;
    SAutoexec: TBitBtn;
    CAutoexec: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ConfigsysClick(Sender: TObject);
    procedure autoexecClick(Sender: TObject);
    procedure SConfigClick(Sender: TObject);
    procedure SAutoexecClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure CAutoexecClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  protected
    BootDrive : Char;
    ConfigName : TFilename;
    Autoexecname : TFilename;
  public
    { Public declarations }
    CSMapperInFile : Integer;
    VMMapperInFile : Integer;
    Restart : Boolean;
    Procedure SaveAutoExec;
    Procedure SaveConfig;
    Function CheckGotCSMapper : Boolean;
    Function CheckGotVMMapper : Boolean;
    Function Go(Express : Boolean; DCS, DVM : Boolean) : Boolean;
    Procedure PrepareInsert(DCS, DVM : Boolean);
    Procedure Summarize;
  end;

var
  ExtraDrivers: TExtraDrivers;

implementation

{$R *.DFM}

uses first;

{ very buggy, but serves in sane cases }
Function DoesExist(line,key : String) : Boolean;
var
  P, S, E : integer;
  check : String;
begin
  { parse away any loadhigh and such }
  Result:=False;
  P:=Pos(lowercase(key),lowercase(line));
  If P=0 then exit;
  { scan backwards to start or to white space, and forward to end or white space }
  S:=p;
  While S>=1 do begin
    If line[s] in [' ','='] then begin
      inc(s);
      break;
    end;
    dec(s);
  end;
  If S=0 then S:=1;
  E:=p;
  While E<=length(line) do begin
    If line[s] in [' ','='] then begin
      dec(e);
      break;
    end;
    inc(e);
  end;
  If E=0 then E:=1;
  check:=copy(line,s,e-s+1);
  Result:=FileExists(check) or FileExists(check+'.com') or FileExists(check+'.exe');
end;

Function GetBootDrive : Char;
var
  Reg : TRegisters;
begin
  Reg.AX:=$3305;
  Reg.DS:=DSeg;
  Reg.ES:=DSeg;
  MSDos(Reg);
  Result:=Char(ord('A')-1+Reg.DL)
end;

procedure TExtraDrivers.FormCreate(Sender: TObject);
begin
  BootDrive:=GetBootDrive;

  Configname:=BootDrive+':\config.sys';
  try
    Configsys.Items.LoadFromfile(Configname);
  except
    On e: Exception do
      Application.ShowException(e);
  end;
  ConfigSource.Caption:=Configname;

  AutoexecName:=BootDrive+':\autoexec.bat';
  try
    Autoexec.Items.Loadfromfile(AutoexecName);
  except
    On e: Exception do
      Application.ShowException(e);
  end;
  AutoexecSource.Caption:=AutoExecName;
end;

Function TExtraDrivers.CheckGotCSMapper;
var
  c : Integer;
  line : String;
begin
  { scan for config.sys for csmapper }
  CSMapperInFile:=-1;
  Result:=False;
  C:=0; while c<ConfigSys.Items.Count do begin
    line:=lowercase(ConfigSys.Items[c]);
    { quick kack rules... }
    If (pos('csmapper.sys',line)<>0) and
       (pos('rem ',line)=0) then begin
         CSMapperInFile:=C;
         Result:=DoesExist(Line,'csmapper');
         ConfigDrivers.Items.AddObject(Line,pointer(longint(c)));
         break;
     end;
     inc(C);
  end;
end;

Function TExtraDrivers.CheckGotVMMapper;
var
  c : Integer;
  line : String;
begin
  { scan for config.sys for csmapper }
  Result:=False;
  VMMapperInFile:=-1;
  C:=0; while c<Autoexec.Items.Count do begin
    line:=lowercase(Autoexec.Items[c]);
    { quick kack rules... }
    If (pos('vmmapper',line)<>0) and
       (pos('rem ',line)=0) then begin
         VMMapperInFile:=c;
         Result:=DoesExist(Line,'vmmapper');
         AutoexecDrivers.Items.AddObject(Line,pointer(longint(c)));
         break;
     end;
     inc(C);
  end;
end;

procedure TExtraDrivers.FormShow(Sender: TObject);
begin
{  PrepareInsert;}
end;

procedure TExtraDrivers.PrepareInsert;
var
  LineNo : Integer;
  Line : String;
  p : pointer;
  Himem, Emm : Boolean;
  Guess : Integer;
  From : Integer;
begin
  If DCS and (ConfigDrivers.Items.Count>0) then begin
    { patch in LineNos }
    { Is a preference specified? }{ probably not... }
    LineNo:=longint(ConfigDrivers.Items.Objects[0])-1;
    { delete and re-make }
    If LineNo>=0 then
      ConfigSys.Items.Delete(LineNo)
    else begin
      { look for a suitable spot... }
      From:=0;
      Guess:=-1;
      LineNo:=0;
      While LineNo<ConfigSys.Items.Count do begin
        Line:=lowercase(ConfigSys.Items[LineNo]);
        If (Guess=-1) and (pos('rem',Line)=0) then
          Guess:=LineNo;
        { reset if we find himem or emm or [common] }
        If (pos('himem',Line)<>0) or (pos('emm',Line)<>0) or
           (pos('[common]',Line)<>0) or (pos('dos',line)<>0) then begin
          Guess:=-1;
          From:=LineNo;
        end;
        inc(LineNo);
      end;
      If Guess=-1 then Guess:=From;
      LineNo:=Guess;
    end;
    ConfigSys.Items.Insert(LineNo,ConfigDrivers.Items[0]);
    ConfigSys.ItemIndex:=LineNo;
    ConfigDrivers.Items.Objects[0]:=pointer(longint(LineNo));
  end else
    TabbedNoteBook1.Pages.Delete(TabbedNotebook1.Pages.IndexOf('Config.sys'));

  If DVM and (AutoexecDrivers.Items.Count>0) then begin
    LineNo:=longint(pointer(AutoexecDrivers.Items.Objects[0]))-1;
    { delete and re-make }
    If LineNo>=0 then
      AutoExec.Items.Delete(LineNo)
    else begin
      { look for a suitable spot... }
      LineNo:=0;
      While LineNo<Autoexec.Items.Count do begin
        Line:=lowercase(Autoexec.Items[LineNo]);
        If (pos('echo',Line)=0) and (pos('rem',Line)=0) then break;
        inc(LineNo);
      end;
    end;
    Autoexec.Items.Insert(LineNo,AutoexecDrivers.Items[0]);
    Autoexec.ItemIndex:=LineNo;
    AutoexecDrivers.Items.Objects[0]:=pointer(longint(LineNo));
  end else
    TabbedNoteBook1.Pages.Delete(TabbedNotebook1.Pages.IndexOf('Autoexec.bat'));
end;

procedure TExtraDrivers.ConfigsysClick(Sender: TObject);
var
  OldIndex, Index : Integer;
begin
  OldIndex:=longint(ConfigDrivers.Items.Objects[0]);
  Index:=ConfigSys.ItemIndex;
  If Index=OldIndex then exit;
  ConfigSys.Items.BeginUpdate;
  try
    If Index<OldIndex then begin
      ConfigSys.Items.Delete(OldIndex);
      ConfigSys.Items.Insert(Index,ConfigDrivers.Items[0]);
    end else begin
      ConfigSys.Items.Insert(Index,ConfigDrivers.Items[0]);
      ConfigSys.Items.Delete(OldIndex);
      dec(Index);
    end;
    ConfigSys.ItemIndex:=Index;
    ConfigDrivers.Items.Objects[0]:=pointer(longint(Index));
  finally
    ConfigSys.Items.EndUpdate;
  end;
end;

procedure TExtraDrivers.autoexecClick(Sender: TObject);
var
  OldIndex, Index : Integer;
begin
  OldIndex:=longint(autoexecDrivers.Items.Objects[0]);
  Index:=autoexec.ItemIndex;
  If Index=OldIndex then exit;
  autoexec.Items.BeginUpdate;
  try
    If Index<OldIndex then begin
      autoexec.Items.Delete(OldIndex);
      autoexec.Items.Insert(Index,autoexecDrivers.Items[0]);
    end else begin
      autoexec.Items.Delete(OldIndex);
      autoexec.Items.Insert(Index,autoexecDrivers.Items[0]);
    end;
    autoexec.ItemIndex:=Index;
    autoexecDrivers.Items.Objects[0]:=pointer(longint(Index));
  finally
    autoexec.Items.EndUpdate;
  end;
end;

procedure TExtraDrivers.SConfigClick(Sender: TObject);
begin
  If CConfig.Enabled then begin
    SaveConfig;
    CConfig.Enabled:=False;
  end;
  If (TabbedNotebook1.PageIndex=TabbedNoteBook1.Pages.Count-1) or (Cautoexec.Enabled=False) then
    Close
  else
    TabbedNotebook1.PageIndex:=TabbedNotebook1.PageIndex+1;
end;

procedure TExtraDrivers.SAutoexecClick(Sender: TObject);
begin
  if CAutoexec.Enabled then begin
    SaveAutoExec;
    CAutoexec.Enabled:=False;
  end;
  If (TabbedNotebook1.PageIndex=0) OR (CConfig.Enabled=False) then
    close
  else
    TabbedNotebook1.PageIndex:=TabbedNotebook1.PageIndex-1;
end;

procedure TExtraDrivers.SaveAutoExec;
var
 Old : String;
begin
  If TabbedNotebook1.Pages.IndexOf('Autoexec.bat')=-1 then exit;
  If autoexecDrivers.Items.Count>0 then begin
    Old:=backup(Autoexecname);
    Autoexec.Items.SaveToFile(Autoexecname);
    If Old='' then
      FirstForm.Log(Format('Created %s',[autoexecname]))
    else
      FirstForm.Log(Format('Changed %s,  Previous file is renamed as %s',[autoexecname,old]));
    ReStart:=True;
  end;
end;

procedure TExtraDrivers.SaveConfig;
var
 Old : String;
begin
  If TabbedNotebook1.Pages.IndexOf('Config.sys')=-1 then exit;
  If ConfigDrivers.Items.Count>0 then begin
    Old:=backup(Configname);
    ConfigSys.Items.SaveToFile(configname);
    If Old='' then
      FirstForm.Log(Format('Created %s',[configname]))
    else
      FirstForm.Log(Format('Changed %s,  Previous file is renamed as %s',[configname,old]));
    ReStart:=True;
  end;
end;

Function TExtraDrivers.Go;
begin
  PrepareInsert(DCS,DVM);
  If not Express then Result:=ShowModal=mrOK else begin
{    PrepareInsert;}
    SaveConfig;
    SaveAutoExec;
    Summarize;
    Result:=true;
  end;
end;

procedure TExtraDrivers.Summarize;
begin
  If Restart then
    FirstForm.Log('You need to restart you computer for the changes to take effect.');
end;

procedure TExtraDrivers.FormHide(Sender: TObject);
begin
  Summarize;
end;

procedure TExtraDrivers.CAutoexecClick(Sender: TObject);
begin
  FirstForm.Log('Changes cancelled.  You system may not be properly installed');
end;

procedure TExtraDrivers.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key=VK_F1 then begin
    With TabbedNoteBook1 do
      Application.HelpContext((Pages.Objects[PageIndex] as TWinControl).HelpContext);
  end;
end;

end.
