unit Pcsetup;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, TabNotBk, windos, Buttons;

type
  TExtraDrivers = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    GroupBox1: TGroupBox;
    Configsys: TListBox;
    ConfigDrivers: TListBox;
    Label2: TLabel;
    autoexec: TListBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    AutoexecDrivers: TListBox;
    AutoExecSource: TLabel;
    ConfigSource: TLabel;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn6: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ConfigsysClick(Sender: TObject);
    procedure autoexecClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
  protected
    BootDrive : Char;
    ConfigSysName : TFilename;
    Autoexecname : TFilename;
    CSMapperInFile : Boolean;
    VMMapperInFile : Boolean;
  public
    { Public declarations }
    Function CheckGotCSMapper : Boolean;
    Function CheckGotVMMapper : Boolean;
    Procedure Go(Express : Boolean);
    Procedure PrepareInsert;
  end;

var
  ExtraDrivers: TExtraDrivers;

implementation

{$R *.DFM}

Function GetBootDrive : Char;
var
  Reg : TRegisters;
begin
  Reg.AX:=$3305;
  Reg.DS:=DSeg;
  Reg.ES:=DSeg;
  MSDos(Reg);
  Result:=Char(ord('A')-1+Reg.DL)
end;

procedure TExtraDrivers.FormCreate(Sender: TObject);
begin
  BootDrive:=GetBootDrive;

  Configsysname:=BootDrive+':\config.sys';
  Configsys.Items.LoadFromfile(ConfigSysname);
  ConfigSource.Caption:=Configsysname;

  AutoexecName:=BootDrive+':\autoexec.bat';
  Autoexec.Items.Loadfromfile(AutoexecName);
  AutoexecSource.Caption:=AutoExecName;
end;

Function TExtraDrivers.CheckGotCSMapper;
var
  c : Integer;
  line : String;
begin
  { scan for config.sys for csmapper }
  Result:=False;
  C:=0; while c<ConfigSys.Items.Count do begin
  line:=lowercase(ConfigSys.Items[c]);
    If (pos('csmapper.sys',line)<>0) and
       (pos('rem ',line)=0) then begin
         Result:=True;
         ConfigDrivers.Items.AddObject(Line,pointer(longint(c)));
         break;
     end;
     inc(C);
  end;
  CSMapperInFile:=Result;
end;

Function TExtraDrivers.CheckGotVMMapper;
var
  c : Integer;
  line : String;
begin
  { scan for config.sys for csmapper }
  Result:=False;
  C:=0; while c<Autoexec.Items.Count do begin
  line:=lowercase(Autoexec.Items[c]);
    If (pos('vmmapper',line)<>0) and
       (pos('rem ',line)=0) then begin
         Result:=True;
         break;
     end;
     inc(C);
  end;
  VMMapperInFile:=Result;
end;

procedure TExtraDrivers.FormShow(Sender: TObject);
begin
  PrepareInsert;
end;

procedure TExtraDrivers.PrepareInsert;
var
  LineNo : Integer;
  Line : String;
begin
  { patch in LineNos }
  LineNo:=longint(ConfigDrivers.Items.Objects[0]);
  { delete and re-make }
  If LineNo<>0 then
    ConfigSys.Items.Delete(LineNo);
  ConfigSys.Items.Insert(LineNo,ConfigDrivers.Items[0]);
  ConfigSys.ItemIndex:=LineNo;
  ConfigDrivers.Items.Objects[0]:=pointer(longint(LineNo));

  LineNo:=longint(AutoexecDrivers.Items.Objects[0]);
  { delete and re-make }
  If LineNo<>0 then
    AutoExec.Items.Delete(LineNo)
  else begin
    { look for a suitable spot... }
    LineNo:=0;
    While LineNo<Autoexec.Items.Count do begin
      Line:=lowercase(Autoexec.Items[LineNo]);
      If pos('echo',Line)=0 then break;
      inc(LineNo);
    end;
  end;
  Autoexec.Items.Insert(LineNo,AutoexecDrivers.Items[0]);
  Autoexec.ItemIndex:=LineNo;
  AutoexecDrivers.Items.Objects[0]:=pointer(longint(LineNo));
end;

procedure TExtraDrivers.ConfigsysClick(Sender: TObject);
var
  OldIndex, Index : Integer;
begin
  OldIndex:=longint(ConfigDrivers.Items.Objects[0]);
  Index:=ConfigSys.ItemIndex;
  If Index=OldIndex then exit;
  ConfigSys.Items.BeginUpdate;
  try
    If Index<OldIndex then begin
      ConfigSys.Items.Delete(OldIndex);
      ConfigSys.Items.Insert(Index,ConfigDrivers.Items[0]);
    end else begin
      ConfigSys.Items.Insert(Index,ConfigDrivers.Items[0]);
      ConfigSys.Items.Delete(OldIndex);
      dec(Index);
    end;
    ConfigSys.ItemIndex:=Index;
    ConfigDrivers.Items.Objects[0]:=pointer(longint(Index));
  finally
    ConfigSys.Items.EndUpdate;
  end;
end;

procedure TExtraDrivers.autoexecClick(Sender: TObject);
var
  OldIndex, Index : Integer;
begin
  OldIndex:=longint(autoexecDrivers.Items.Objects[0]);
  Index:=autoexec.ItemIndex;
  If Index=OldIndex then exit;
  autoexec.Items.BeginUpdate;
  try
    If Index<OldIndex then begin
      autoexec.Items.Delete(OldIndex);
      autoexec.Items.Insert(Index,autoexecDrivers.Items[0]);
    end else begin
      autoexec.Items.Delete(OldIndex);
      autoexec.Items.Insert(Index,autoexecDrivers.Items[0]);
    end;
    autoexec.ItemIndex:=Index;
    autoexecDrivers.Items.Objects[0]:=pointer(longint(Index));
  finally
    autoexec.Items.EndUpdate;
  end;
end;

procedure TExtraDrivers.BitBtn1Click(Sender: TObject);
begin
  ConfigSys.Items.SaveToFile(ConfigSysname);
  TabbedNotebook1.PageIndex:=TabbedNotebook1.PageIndex+1;
end;

procedure TExtraDrivers.BitBtn4Click(Sender: TObject);
begin
  Autoexec.Items.SaveToFile(Autoexecname);
end;

procedure TExtraDrivers.Go;
begin
  If not Express then ShowModal else begin
    PrepareInsert;
    ConfigSys.Items.SaveToFile(ConfigSysname);
    Autoexec.Items.SaveToFile(Autoexecname);
  end;
end;

end.
