unit PrevInst;
{*** Detects a previous instance of the program running and goes to it ***}
{ lifted largely of a comp.lang.pascal.delphi.misc news article }
interface
uses
  WinTypes, WinProcs, SysUtils, toolhelp;

type
  PHWND = ^HWND;

  function EnumFunc(Wnd:HWND; TargetWindow:PHWND): bool; export;
  procedure GotoPreviousInstance;

implementation

Function GetParentPath : String;
Var
  taskEntry : TTaskEntry;
  Moduleentry : TModuleEntry;
begin
  TasKEntry.dwsize:=sizeof(taskentry);
  ModuleEntry.dwsize:=sizeof(moduleentry);
  TaskFindHandle(@TaskEntry,GetCurrentTask);
  TaskFindHandle(@TaskEntry,TaskEntry.htaskParent);
  ModuleFindHandle(@Moduleentry,TaskEntry.hModule);
  Result:=StrPas(ModuleEntry.szModule);
end;

Function GetParentName : String;
Var
  taskEntry : TTaskEntry;
  Moduleentry : TModuleEntry;
begin
  TasKEntry.dwsize:=sizeof(taskentry);
  ModuleEntry.dwsize:=sizeof(moduleentry);
  TaskFindHandle(@TaskEntry,GetCurrentTask);
  TaskFindHandle(@TaskEntry,TaskEntry.htaskParent);
  ModuleFindHandle(@Moduleentry,TaskEntry.hModule);
  Result:=StrPas(ModuleEntry.szExePath);
end;

function EnumFunc(Wnd:HWND; TargetWindow:PHWND): bool;
var
  ClassName : array[0..30] of char;
begin
  Result := true;
  if GetWindowWord(Wnd,GWW_HINSTANCE) = hPrevInst then begin
     GetClassName(Wnd,ClassName,30);
     if StrIComp(ClassName,'TApplication') = 0 then begin
       TargetWindow^ := Wnd;
       Result := false;
     end;
   end;
end;

procedure GotoPreviousInstance;
var
  PrevInstWnd : HWND;
begin
  PrevInstWnd := 0;
  EnumWindows(@EnumFunc,longint(@PrevInstWnd));
  if PrevInstWnd <> 0 then
    if IsIconic(PrevInstWnd) then ShowWindow(PrevInstWnd,SW_RESTORE)
    else BringWindowToTop(PrevInstWnd);
end;

end.  {of unit PrevIns }



